; World in 3D -- a ray caster engine for Ti-92
; Copyright (C) 1998-1999 Silicone <Julien.Viard@enst.fr>
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


;  routines d'affichage de World in 3D V0.33Beta


	xdef    affichage
	xdef    effacement
        xdef    calcsin


        xdef    map
        xdef    pos_x
        xdef    pos_y
        xdef    pos_a

        xdef    objlist
        xdef    actweapon_m
        xdef    actweapon_s

        xdef    strmlist
        xdef    strm_col

;*****************************************************
;       CODE
;*****************************************************

;
;

affweaponspr:
        move.l actweapon_s,a1
        move.l act_scr,a0
        add.w (a1)+,a0 ; spr pos
        clr.l d0
        clr.l d1
        move.b (a1)+,d0 ; x size
        beq affweaponspr_fin
        move.b (a1)+,d1 ; y size

        move.l #30,d3
        sub.l d0,d3

        sub.l #1,d1
affweaponspr_ybcle:
         move.l d0,d2
         sub.l #1,d2
affweaponspr_xbcle:
          move.b (a1)+,(a0)+
          dbra d2,affweaponspr_xbcle
         add.l d3,a0
         dbra d1,affweaponspr_ybcle

affweaponspr_fin:
        rts

affcolone:
        lea colone,a0
        move.l #59,d0
        clr.l d1
affcolone_boucle:
         move.b (a0)+,d1
         cmp.b #1,d1
          ble affcolone_noaff
          sub.b #2,d1
          add.b d1,d1
          add.b d7,d1
          move.w 0(a3,d1.w),d2   ; sprite
          or.b d2,(a2)
          lsr.w #8,d2
          or.b d2,30(a2)
affcolone_noaff:
        add #60,a2
        dbra d0,affcolone_boucle
        rts

aff_weapon:
        move.l actweapon_m,a1
        clr.l d2
        move.b actcol,d2
        sub.b (a1)+,d2
        blt clear_colone
        cmp.b (a1)+,d2
        bge clear_colone
;        mulu #8,d2
        lsl.l #3,d2 ;*8
        add.l d2,a1  ; dcalage...
        move.l #61,d0
        clr.l d2
        lea colone,a0
aff_weapon_bcle:
        btst d2,(a1)
        bne aff_weapon_nontransp
        clr.b (a0)+
        bra aff_weapon_ok
aff_weapon_nontransp:
        move.b #1,(a0)+
aff_weapon_ok:
        add.b #1,d2
        and.b #7,d2
        bne aff_weapon_noadr
        add.l #1,a1
aff_weapon_noadr:
        dbra d0,aff_weapon_bcle
        rts

clear_colone:
        lea colone,a0
        move.l #14,d0
        clr.l d1
clear_colone_bcle:
        move.l d1,(a0)+
        dbra d0,clear_colone_bcle
        rts

zoomvertical
        lea colone,a0
        move.l #$2000,d2    ; $1000 = 1 shl (siz2 + coef2)
        divu d0,d2
        move.l d0,d1
        clr.l d4
        cmp.w #30,d2
        ble zoomvertical_normal
         sub.w #30,d2
         mulu.w d1,d2
         move.w d2,d4
         move.w #30,d2
         bra zoomvertical_suite
zoomvertical_normal:
         add.w #30,a0
         sub.w d2,a0
zoomvertical_suite:
        clr.l d3
        move.w d2,d3
        add.l d3,d3
        clr.l d5
zoomvertical_boucle:
          move.w d4,d5
          lsr #6,d5   ; #5
          and.w #$f0,d5   ; = not f  mask // siz2
          tst.b (a0)
          bgt zoomvertical_non_transparent
          move.b 0(a1,d5.w),(a0)
           bne zoomvertical_non_transparent ; pour tester la presence d'un
           clr.b istransp                   ; pixel transparent dans la colone
zoomvertical_non_transparent:
          add.l #1,a0
          add.l d1,d4
          dbra d3,zoomvertical_boucle

        rts

define_obj:
	movem.l	d0-d5,-(sp)
        lea atn_tbl,a4
        clr.b d2
        clr.b d3

        move.l oposx(a1),d0
        sub.l pos_x,d0
        bpl defobj_dxpos
        neg.l d0
        move.b #1,d2
defobj_dxpos:

        move.l oposy(a1),d1
        sub.l pos_y,d1
        bpl defobj_dypos
        neg.l d1
        move.b #1,d3
defobj_dypos:

        cmp.l d1,d0
        bge defobj_dxsupdy
        move.l d0,d5
        lsl.l #6,d5   ; *64
        divu d1,d5    ; dep ?

        move.b 0(a4,d5.w),d5 ; arctan
        ext.w d5
        neg.w d5
        add.w #128,d5
        bra defobj_atndone
defobj_dxsupdy:
        tst.l d0
        beq defobj_dxnull
        move.l d1,d5
        lsl.l #6,d5   ; *64
        divu d0,d5    ; dep ?

        move.b 0(a4,d5.w),d5 ; arctan
        ext.w d5
        bra defobj_atndone
defobj_dxnull:
        move.w 128,d5
defobj_atndone:
        tst.b d2
        beq defobj_nodxneg
        neg.w d5
        add.w #256,d5
defobj_nodxneg:
        tst.b d3
        beq defobj_nodyneg
        neg.w d5
;        add.w #512,d5
defobj_nodyneg:
        and.w #$1FF,d5
        move.w d5,oangle(a1)



	mulu.w		d0,d0
	mulu.w		d1,d1
	add.l		d0,d1		;d0=x^2+y^2

	moveq		#1,d0		;Odd number counter
	moveq		#-1,d5		;Returned value

\loop	sub.l		d0,d1
	addq.l		#2,d0
	addq.l		#1,d5
	tst.l		d1
	bge.s		\loop

        move.l d5,odist(a1)

        move.l actcount,d5
        move.l d5,ocount(a1)

	movem.l	(sp)+,d0-d5
        rts

; recherche sur X
recherche_mur_dX:
        tst.w d0
        beq recherche_mur_distXinf
        ble recherche_mur_dXneg
recherche_mur_dXpos:
          move.l d1,d2
          asl.l #8,d2
          divs d0,d2
          bvs recherche_mur_distXinf
          ext.l d2
          move.l pos_x,d3
          lsr.l #7,d3
          and.l #$1E,d3
          lea map(pc),a0
          add.l d3,a0         ; map + c
          move.l pos_x,d3
          and.l #$ff,d3
          muls d2,d3
          neg.l d3 
          asr.l #8,d3
          add.l pos_y,d3      ; yd
          add.l d3,d3         ; *2
recherche_mur_bcleXptq:
            move.l d3,d4
            lsr.l #4,d4
            and.l #$1E0,d4
            tst.w 0(a0,d4)
            beq recherche_mur_bcleXp_mur_obj_cont
            btst.w #14,0(a0,d4)
            beq trouv_mur_obj_Xp
recherche_mur_bcleXp_mur_obj_cont:
            add.l d2,d3
            cmp #$1FFF,d3
            bgt recherche_mur_distXinf
            move.l d3,d4
            lsr.l #4,d4
            and.l #$1E0,d4
            btst.w #14,0(a0,d4)
            beq recherche_mur_bcleXp_porte_cont
            btst.w #13,0(a0,d4)
            beq trouv_porte_Xp_I
recherche_mur_bcleXp_porte_cont:
            add.l #2,a0
            add.l d2,d3
            cmp #$1FFF,d3
            ble recherche_mur_bcleXptq
            bra recherche_mur_distXinf

trouv_mur_obj_Xp:
            btst.w #13,0(a0,d4)
            beq trouv_obj_Xp
trouv_mur_Xp:
          move.w -2(a0,d4),textX  ; case prcedente
          move.b textX,d5    ; poids fort -> type
          and.b #$60,d5
; def le no de texture de mur de porte
          and.w #$3,textX
          beq trouv_mur_Xp_ok1 ; texture 0 on aff le mur de toute faon!
          add #textmur,textX
          cmp.b #$60,d5
          beq trouv_mur_Xp_ok    ; ok c'est une porte H...
trouv_mur_Xp_ok1:
          move.w 0(a0,d4),textX  ; non, on prend la texture du mur.
trouv_mur_Xp_ok:
          move.l d3,d4
          lsr.l #5,d4
          and.l #$F,d4
          move.l d4,postX
          lea map(pc),a1
          move.l a0,d4
          sub.l a1,d4
          asl.l #7,d4
          sub.l pos_x,d4
          asl.l #7,d4
          divs d0,d4
          bvs recherche_mur_distXinf ;???
          ext.l d4
          move.l d4,distX
          ble recherche_mur_bcleXp_mur_obj_cont ; distance negative ou nulle !
          clr.b contX
          rts
trouv_obj_Xp:   
          move.w 0(a0,d4),d5
          subq #1,d5
          and.w #$1FFF,d5
          mulu.w #osize,d5
          lea objlist,a1
          add.w d5,a1
          move.l ocount(a1),d5
          cmp.l actcount,d5
          beq trouv_obj_Xp_dejatrouve
          jsr define_obj
trouv_obj_Xp_dejatrouve:
          move.w d6,d5
          sub.w oangle(a1),d5

          add.w #256,d5
          and.w #$1FF,d5
          sub.w #256,d5   ; d5 in ]-Pi,+Pi[

          muls #50,d5
          muls odist+2(a1),d5
          swap.l d5         ; div 65536!!!
          ext.l d5

          add.l #8,d5
          cmp.l #16,d5
          bcc recherche_mur_bcleXp_mur_obj_cont ; hors de la texture
          move.l d5,postX
          move.l odist(a1),distX
          move.w otext(a1),textX

          clr.l d5                      ; test de col vide id:-1
          move.w textX,d5
          and.w #$1FF,d5
          lsl.l #8,d5
          add.l postX,d5
          lea textures_mur(pc),a1
          add.l d5,a1
          tst.b (a1)
          blt recherche_mur_bcleXp_mur_obj_cont ; colone vide


; !! un obj est transparent !
          move.b #1,contX   ; continue aprs un obj !
          move.l a0,adr_X
          move.l d3,dec_X
          move.l d2,pas_X
          move.l d1,sin
          move.l d0,cos

          rts

trouv_porte_Xp_I:
          move.w 0(a0,d4),textX
          move.b textX,d5  ;type
          and.b #$18,d5    ;type de porte

          move.l d3,d4
          lsr.l #5,d4
          cmp.b #$10,d5
          bne trouv_porte_Xp_Iinv ; invertion de la texture ...
          not.l d4
trouv_porte_Xp_Iinv:
          and.l #$F,d4
          move.l d4,postX
          lea map(pc),a1
          move.l a0,d4
          add.l #1,d4       ; case + 1/2
          sub.l a1,d4
          asl.l #7,d4
          sub.l pos_x,d4
          asl.l #7,d4
          divs d0,d4
          bvs recherche_mur_distXinf ;???
          ext.l d4
          move.l d4,distX
          ble recherche_mur_bcleXp_porte_cont ; distance negative !

; faire le dcalage de l'ouverture et adapter le no de texture
          move.w textX,d4
          lsr.w #2,d4
          and.w #$1FF,d4
          cmp.b #$08,d5
          beq trouv_porte_Xp_I_01
          and.w #$F,d4

          cmp.b #$00,d5
          bne trouv_porte_Xp_I_1v
trouv_porte_Xp_I_00:
          clr.l d5
          move.b textX,d5
          and.b #7,d5
          cmp.l #8,postX
          bge trouv_porte_Xp_I_00s
trouv_porte_Xp_I_00i:
          add.l d5,postX
          cmp.l #8,postX
          bge recherche_mur_bcleXp_porte_cont ; dans l'ouverture !
          bra trouv_porte_Xp_I_01
trouv_porte_Xp_I_00s:
          sub.l d5,postX
          cmp.l #8,postX
          bge trouv_porte_Xp_I_01  ; ok ...
          bra recherche_mur_bcleXp_porte_cont ; dans l'ouverture !

trouv_porte_Xp_I_1v:
          clr.l d5
          move.b textX,d5
          and.b #7,d5
          add.b d5,d5   ; *2
          add.l d5,postX
          cmp.l #16,postX
          bge recherche_mur_bcleXp_porte_cont ; dans l'ouverture !
trouv_porte_Xp_I_01:
          add #textporte,d4
          move.w d4,textX

; !! dans cette dir la porte est transparente !
          move.b #2,contX   ; continue aprs une porte !
          move.l a0,adr_X
          move.l d3,dec_X
          move.l d2,pas_X
          move.l d1,sin
          move.l d0,cos

          rts


recherche_mur_dXneg:
          move.l d1,d2
          asl.l #8,d2
          divs d0,d2
          bvs recherche_mur_distXinf
          ext.l d2
          move.l pos_x,d3
          sub.l #1,d3 
          lsr.l #7,d3
          and.l #$1E,d3
          lea map(pc),a0
          add.l d3,a0         ; map + c
          move.l pos_x,d3
          neg.l d3  
          and.l #$ff,d3
          muls d2,d3
          asr.l #8,d3
          add.l pos_y,d3      ; yd
          add.l d3,d3         ; *2
recherche_mur_bcleXntq:
            move.l d3,d4
            lsr.l #4,d4
            and.l #$1E0,d4
            tst.w 0(a0,d4)
            beq recherche_mur_bcleXn_mur_obj_cont
            btst.w #14,0(a0,d4)
            beq trouv_mur_obj_Xn

recherche_mur_bcleXn_mur_obj_cont:
            sub.l d2,d3
            cmp #$1FFF,d3
            bgt recherche_mur_distXinf
            move.l d3,d4
            lsr.l #4,d4
            and.l #$1E0,d4
            btst.w #14,0(a0,d4)
            beq recherche_mur_bcleXn_porte_cont
            btst.w #13,0(a0,d4)
            beq trouv_porte_Xn_I
recherche_mur_bcleXn_porte_cont:
            sub.l #2,a0
            sub.l d2,d3
            cmp #$1FFF,d3
            ble recherche_mur_bcleXntq
            bra recherche_mur_distXinf

trouv_mur_obj_Xn:
            btst.w #13,0(a0,d4)
            beq trouv_obj_Xn
trouv_mur_Xn:
          move.w +2(a0,d4),textX  ; case prcedente

          move.b textX,d5    ; poids fort -> type
          and.b #$60,d5

; def le no de texture de mur de porte
          and.w #$3,textX
          beq trouv_mur_Xn_ok1 ; texture 0 on aff le mur de toute faon!

          add #textmur,textX

          cmp.b #$60,d5
          beq trouv_mur_Xn_ok    ; ok c'est une porte H...
trouv_mur_Xn_ok1:
          move.w 0(a0,d4),textX  ; non, on prend la texture du mur.
trouv_mur_Xn_ok:
          move.l d3,d4
          not.l d4
          lsr.l #5,d4
          and.l #$F,d4
          move.l d4,postX
          lea map(pc),a1
          move.l a0,d4
          sub.l a1,d4
          add.l #2,d4
          asl.l #7,d4
          sub.l pos_x,d4
          asl.l #7,d4
          divs d0,d4
          bvs recherche_mur_distXinf ;???
          ext.l d4
          move.l d4,distX
          ble recherche_mur_bcleXn_mur_obj_cont ; distance negative !
          clr.b contX
          rts
trouv_obj_Xn:
          move.w 0(a0,d4),d5
          subq #1,d5
          and.w #$1FFF,d5
          mulu.w #osize,d5
          lea objlist,a1
          add.w d5,a1
          move.l ocount(a1),d5
          cmp.l actcount,d5
          beq trouv_obj_Xn_dejatrouve
          jsr define_obj
trouv_obj_Xn_dejatrouve:
          move.w d6,d5
          sub.w oangle(a1),d5

          add.w #256,d5
          and.w #$1FF,d5
          sub.w #256,d5   ; d5 in ]-Pi,+Pi[

          muls #50,d5
          muls odist+2(a1),d5
          swap.l d5         ; div 65536!!!
          ext.l d5

          add.l #8,d5
          cmp.l #16,d5
          bcc recherche_mur_bcleXn_mur_obj_cont ; hors de la texture
          move.l d5,postX
          move.l odist(a1),distX
          move.w otext(a1),textX

          clr.l d5                      ; test de col vide id:-1
          move.w textX,d5
          and.w #$1FF,d5
          lsl.l #8,d5
          add.l postX,d5
          lea textures_mur(pc),a1
          add.l d5,a1
          tst.b (a1)
          blt  recherche_mur_bcleXn_mur_obj_cont ; colone vide


; !! un obj est transparent !
          move.b #1,contX   ; continue aprs un obj !
          move.l a0,adr_X
          move.l d3,dec_X
          move.l d2,pas_X
          move.l d1,sin
          move.l d0,cos

          rts

trouv_porte_Xn_I:
          move.w 0(a0,d4),textX
          move.b textX,d5  ;type
          and.b #$18,d5    ;type de porte

          move.l d3,d4
          lsr.l #5,d4
          btst.b #3,d5
          bne trouv_porte_Xn_Iinv ; invertion de la texture ...
          not.l d4
trouv_porte_Xn_Iinv:
          and.l #$F,d4
          move.l d4,postX
          lea map(pc),a1
          move.l a0,d4
          add.l #1,d4       ; case + 1/2
          sub.l a1,d4
          asl.l #7,d4
          sub.l pos_x,d4
          add.l #2,d4
          asl.l #7,d4
          divs d0,d4
          bvs recherche_mur_distXinf ;???
          ext.l d4
          move.l d4,distX
          ble recherche_mur_bcleXn_porte_cont ; distance negative !

; faire le dcalage de l'ouverture et adapter le no de texture
          move.w textX,d4
          lsr.w #2,d4
          and.w #$1FF,d4
          cmp.b #$08,d5
          beq trouv_porte_Xp_I_01
          and.w #$F,d4

          cmp.b #$00,d5
          bne trouv_porte_Xn_I_1v
trouv_porte_Xn_I_00:
          clr.l d5
          move.b textX,d5
          and.b #7,d5
          cmp.l #8,postX
          bge trouv_porte_Xn_I_00s
trouv_porte_Xn_I_00i:
          add.l d5,postX
          cmp.l #8,postX
          bge recherche_mur_bcleXn_porte_cont ; dans l'ouverture !
          bra trouv_porte_Xp_I_01
trouv_porte_Xn_I_00s:
          sub.l d5,postX
          cmp.l #8,postX
          bge trouv_porte_Xn_I_01  ; ok ...
          bra recherche_mur_bcleXn_porte_cont ; dans l'ouverture !

trouv_porte_Xn_I_1v:
          clr.l d5
          move.b textX,d5
          and.b #7,d5
          add.b d5,d5   ; *2
          add.l d5,postX
          cmp.l #16,postX
          bge recherche_mur_bcleXn_porte_cont ; dans l'ouverture !


trouv_porte_Xn_I_01:
          add #textporte,d4
          move.w d4,textX

; !! dans cette dir la porte est transparente !
          move.b #2,contX   ; continue aprs une porte !
          move.l a0,adr_X
          move.l d3,dec_X
          move.l d2,pas_X
          move.l d1,sin
          move.l d0,cos

          rts

cont_recherche_mur_dX_porte:

        move.l adr_X,a0
        move.l dec_X,d3
        move.l pas_X,d2
        move.l sin,d1
        move.l cos,d0
;;        tst.w d0   ;;deja fait par le move!!
        bgt recherche_mur_bcleXp_porte_cont
        blt recherche_mur_bcleXn_porte_cont
        bra recherche_mur_distXinf

cont_recherche_mur_dX_obj:

        move.l adr_X,a0
        move.l dec_X,d3
        move.l pas_X,d2
        move.l sin,d1
        move.l cos,d0
;;        tst.w d0   ;;deja fait par le move!!
        bgt recherche_mur_bcleXp_mur_obj_cont
        blt recherche_mur_bcleXn_mur_obj_cont

recherche_mur_distXinf:
        move.l #$FFFFFFFF,distX
        clr.b contX
        rts



; recherche sur Y
recherche_mur_dY:
        tst.w d1
        beq recherche_mur_distYinf
        ble recherche_mur_dYneg
recherche_mur_dYpos:
          move.l d0,d2
          asl.l #8,d2
          divs d1,d2
          bvs recherche_mur_distYinf
          ext.l d2
          move.l pos_y,d3
          lsr.l #3,d3
          and.l #$1E0,d3
          lea map(pc),a0
          add.l d3,a0         ; map + l
          move.l pos_y,d3
          and.l #$ff,d3
          muls d2,d3
          neg.l d3
          asr.l #8,d3
          add.l pos_x,d3      ; xd
          add.l d3,d3         ; *2
recherche_mur_bcleYptq:
            move.l d3,d4
            lsr.l #8,d4
            and.l #$1E,d4
            tst.w 0(a0,d4)
            beq recherche_mur_bcleYp_mur_obj_cont
            btst.w #14,0(a0,d4)
            beq trouv_mur_obj_Yp
recherche_mur_bcleYp_mur_obj_cont:
            add.l d2,d3
            cmp #$1FFF,d3
            bgt recherche_mur_distYinf
            move.l d3,d4
            lsr.l #8,d4
            and.l #$1E,d4
            btst.w #14,0(a0,d4)
            beq recherche_mur_bcleYp_porte_cont
            btst.w #13,0(a0,d4)
            bne trouv_porte_Yp_H
recherche_mur_bcleYp_porte_cont:
            add.l #32,a0
            add.l d2,d3
            cmp #$1FFF,d3
            ble recherche_mur_bcleYptq
            bra recherche_mur_distYinf

trouv_mur_obj_Yp:
            btst.w #13,0(a0,d4)
            beq trouv_obj_Yp
trouv_mur_Yp:
          move.w -32(a0,d4),textY  ; case prcedente
          move.b textY,d5    ; poids fort -> type
          and.b #$60,d5
; def le no de texture de mur de porte
          and.w #$3,textY
          beq trouv_mur_Yp_ok1 ; texture 0 on aff le mur de toute faon!

          add #textmur,textY
          cmp.b #$40,d5
          beq trouv_mur_Yp_ok    ; ok c'est une porte I...
trouv_mur_Yp_ok1:
          move.w 0(a0,d4),textY  ; non, on prend la texture du mur.
trouv_mur_Yp_ok:
          move.l d3,d4
          not.l d4
          lsr.l #5,d4
          and.l #$F,d4
          move.l d4,postY
          lea map(pc),a1
          move.l a0,d4
          sub.l a1,d4
          asl.l #3,d4
          sub.l pos_y,d4
          asl.l #7,d4
          divs d1,d4
          bvs recherche_mur_distYinf ;???
          ext.l d4
          move.l d4,distY
          ble recherche_mur_bcleYp_mur_obj_cont ; distance negative !
          clr.b contY
          rts
trouv_obj_Yp:
          move.w 0(a0,d4),d5
          subq #1,d5
          and.w #$1FFF,d5
          mulu.w #osize,d5
          lea objlist,a1
          add.w d5,a1
          move.l ocount(a1),d5
          cmp.l actcount,d5
          beq trouv_obj_Yp_dejatrouve
          jsr define_obj
trouv_obj_Yp_dejatrouve:
          move.w d6,d5
          sub.w oangle(a1),d5

          add.w #256,d5
          and.w #$1FF,d5
          sub.w #256,d5   ; d5 in ]-Pi,+Pi[

          muls #50,d5
          muls odist+2(a1),d5
          swap.l d5         ; div 65536!!!
          ext.l d5

          add.l #8,d5
          cmp.l #16,d5
          bcc recherche_mur_bcleYp_mur_obj_cont ; hors de la texture
          move.l d5,postY
          move.l odist(a1),distY
          move.w otext(a1),textY

          clr.l d5                      ; test de col vide id:-1
          move.w textY,d5
          and.w #$1FF,d5
          lsl.l #8,d5
          add.l postY,d5
          lea textures_mur(pc),a1
          add.l d5,a1
          tst.b (a1)
          blt recherche_mur_bcleYp_mur_obj_cont ; colone vide


; !! un obj est transparent !
          move.b #1,contY   ; continue aprs un obj !
          move.l a0,adr_Y
          move.l d3,dec_Y
          move.l d2,pas_Y
          move.l d1,sin
          move.l d0,cos

          rts

trouv_porte_Yp_H:
          move.w 0(a0,d4),textY
          move.b textY,d5  ;type
          and.b #$18,d5    ;type de porte

          move.l d3,d4
          lsr.l #5,d4
          cmp.b #$10,d5
          beq trouv_porte_Yp_Iinv ; invertion de la texture ...
          not.l d4
trouv_porte_Yp_Iinv:
          and.l #$F,d4
          move.l d4,postY
          lea map(pc),a1
          move.l a0,d4
          add.l #16,d4       ; case + 1/2
          sub.l a1,d4
          asl.l #3,d4
          sub.l pos_y,d4
          asl.l #7,d4
          divs d1,d4
          bvs recherche_mur_distYinf ;???
          ext.l d4
          move.l d4,distY
          ble recherche_mur_bcleYp_porte_cont ; distance negative !

; faire le dcalage de l'ouverture et adapter le no de texture
          move.w textY,d4
          lsr.w #2,d4
          and.w #$1FF,d4
          cmp.b #$08,d5
          beq trouv_porte_Yp_I_01
          and.w #$F,d4

          cmp.b #$00,d5
          bne trouv_porte_Yp_I_1v
trouv_porte_Yp_I_00:
          clr.l d5
          move.b textY,d5
          and.b #7,d5
          cmp.l #8,postY
          bge trouv_porte_Yp_I_00s
trouv_porte_Yp_I_00i:
          add.l d5,postY
          cmp.l #8,postY
          bge recherche_mur_bcleYp_porte_cont ; dans l'ouverture !
          bra trouv_porte_Yp_I_01
trouv_porte_Yp_I_00s:
          sub.l d5,postY
          cmp.l #8,postY
          bge trouv_porte_Yp_I_01  ; ok ...
          bra recherche_mur_bcleYp_porte_cont ; dans l'ouverture !

trouv_porte_Yp_I_1v:
          clr.l d5
          move.b textY,d5
          and.b #7,d5
          add.b d5,d5   ; *2
          add.l d5,postY
          cmp.l #16,postY
          bge recherche_mur_bcleYp_porte_cont ; dans l'ouverture !
trouv_porte_Yp_I_01:
          add #textporte,d4
          move.w d4,textY

; !! dans cette dir la porte est transparente !
          move.b #2,contY   ; continue aprs une porte !
          move.l a0,adr_Y
          move.l d3,dec_Y
          move.l d2,pas_Y
          move.l d1,sin
          move.l d0,cos

          rts


recherche_mur_dYneg:
          move.l d0,d2
          asl.l #8,d2
          divs d1,d2
          bvs recherche_mur_distYinf
          ext.l d2
          move.l pos_y,d3
          sub.l #1,d3 
          lsr.l #3,d3
          and #$1E0,d3
          lea map(pc),a0
          add.l d3,a0         ; map + l
          move.l pos_y,d3
          neg.l d3
          and.l #$ff,d3
          muls d2,d3
          asr.l #8,d3
          add.l pos_x,d3      ; xd
          add.l d3,d3         ; *2
recherche_mur_bcleYntq:
            move.l d3,d4
            lsr.l #8,d4
            and.l #$1E,d4
            tst.w 0(a0,d4)
            beq recherche_mur_bcleYn_mur_obj_cont
            btst.w #14,0(a0,d4)
            beq trouv_mur_obj_Yn
recherche_mur_bcleYn_mur_obj_cont:
            sub.l d2,d3
            cmp #$1FFF,d3
            bgt recherche_mur_distYinf
            move.l d3,d4
            lsr.l #8,d4
            and.l #$1E,d4
            btst.w #14,0(a0,d4)
            beq recherche_mur_bcleYn_porte_cont
            btst.w #13,0(a0,d4)
            bne trouv_porte_Yn_H
recherche_mur_bcleYn_porte_cont:
            sub.l #32,a0
            sub.l d2,d3
            cmp #$1FFF,d3
            ble recherche_mur_bcleYntq
            bra recherche_mur_distYinf

trouv_mur_obj_Yn:
            btst.w #13,0(a0,d4)
            beq trouv_obj_Yn
trouv_mur_Yn:
          move.w 32(a0,d4),textY  ; case prcedente
          move.b textY,d5    ; poids fort -> type
          and.b #$60,d5
; def le no de texture de mur de porte
          and.w #$3,textY
          beq trouv_mur_Yn_ok1 ; texture 0 on aff le mur de toute faon!

          add #textmur,textY
          cmp.b #$40,d5
          beq trouv_mur_Yn_ok    ; ok c'est une porte I...
trouv_mur_Yn_ok1:
          move.w 0(a0,d4),textY  ; non, on prend la texture du mur.
trouv_mur_Yn_ok:
          move.l d3,d4
          lsr.l #5,d4
          and.l #$F,d4
          move.l d4,postY
          lea map(pc),a1
          move.l a0,d4
          sub.l a1,d4
          add.l #32,d4
          asl.l #3,d4
          sub.l pos_y,d4
          asl.l #7,d4
          divs d1,d4
          bvs recherche_mur_distYinf ;???
          ext.l d4
          move.l d4,distY
          ble recherche_mur_bcleYn_mur_obj_cont ; distance negative !
          clr.b contY
          rts
trouv_obj_Yn:
          move.w 0(a0,d4),d5
          subq #1,d5
          and.w #$1FFF,d5
          mulu.w #osize,d5
          lea objlist,a1
          add.w d5,a1
          move.l ocount(a1),d5
          cmp.l actcount,d5
          beq trouv_obj_Yn_dejatrouve
          jsr define_obj
trouv_obj_Yn_dejatrouve:
          move.w d6,d5
          sub.w oangle(a1),d5

          add.w #256,d5
          and.w #$1FF,d5
          sub.w #256,d5   ; d5 in ]-Pi,+Pi[

          muls #50,d5
          muls odist+2(a1),d5
          swap.l d5         ; div 65536!!!
          ext.l d5

          add.l #8,d5
          cmp.l #16,d5
          bcc recherche_mur_bcleYn_mur_obj_cont ; hors de la texture
          move.l d5,postY
          move.l odist(a1),distY
          move.w otext(a1),textY

          clr.l d5                      ; test de col vide id:-1
          move.w textY,d5
          and.w #$1FF,d5
          lsl.l #8,d5
          add.l postY,d5
          lea textures_mur(pc),a1
          add.l d5,a1
          tst.b (a1)
          blt recherche_mur_bcleYn_mur_obj_cont ; colone vide


; !! un obj est transparent !
          move.b #1,contY   ; continue aprs un obj !
          move.l a0,adr_Y
          move.l d3,dec_Y
          move.l d2,pas_Y
          move.l d1,sin
          move.l d0,cos

          rts

trouv_porte_Yn_H:
          move.w 0(a0,d4),textY
          move.b textY,d5  ;type
          and.b #$18,d5    ;type de porte

          move.l d3,d4
          lsr.l #5,d4
          btst.b #3,d5
          beq trouv_porte_Yn_Iinv ; invertion de la texture ...
          not.l d4
trouv_porte_Yn_Iinv:
          and.l #$F,d4
          move.l d4,postY
          lea map(pc),a1
          move.l a0,d4
          add.l #16,d4       ; case + 1/2
          sub.l a1,d4
          asl.l #3,d4
          sub.l pos_y,d4
          asl.l #7,d4
          divs d1,d4
          bvs recherche_mur_distYinf ;???
          ext.l d4
          move.l d4,distY
          ble recherche_mur_bcleYn_porte_cont ; distance negative !

; faire le dcalage de l'ouverture et adapter le no de texture
          move.w textY,d4
          lsr.w #2,d4
          and.w #$1FF,d4
          cmp.b #$08,d5
          beq trouv_porte_Yn_I_01
          and.w #$F,d4

          cmp.b #$00,d5
          bne trouv_porte_Yn_I_1v
trouv_porte_Yn_I_00:
          clr.l d5
          move.b textY,d5
          and.b #7,d5
          cmp.l #8,postY
          bge trouv_porte_Yn_I_00s
trouv_porte_Yn_I_00i:
          add.l d5,postY
          cmp.l #8,postY
          bge recherche_mur_bcleYn_porte_cont ; dans l'ouverture !
          bra trouv_porte_Yn_I_01
trouv_porte_Yn_I_00s:
          sub.l d5,postY
          cmp.l #8,postY
          bge trouv_porte_Yn_I_01  ; ok ...
          bra recherche_mur_bcleYn_porte_cont ; dans l'ouverture !

trouv_porte_Yn_I_1v:
          clr.l d5
          move.b textY,d5
          and.b #7,d5
          add.b d5,d5   ; *2
          add.l d5,postY
          cmp.l #16,postY
          bge recherche_mur_bcleYn_porte_cont ; dans l'ouverture !
trouv_porte_Yn_I_01:
          add #textporte,d4
          move.w d4,textY

; !! dans cette dir la porte est transparente !
          move.b #2,contY   ; continue aprs une porte !
          move.l a0,adr_Y
          move.l d3,dec_Y
          move.l d2,pas_Y
          move.l d1,sin
          move.l d0,cos

          rts

cont_recherche_mur_dY_porte:

        move.l adr_Y,a0
        move.l dec_Y,d3
        move.l pas_Y,d2
        move.l cos,d0
        move.l sin,d1
;;        tst.w d1   ;;deja fait par le move!!
        bgt recherche_mur_bcleYp_porte_cont
        blt recherche_mur_bcleYn_porte_cont
        bra recherche_mur_distYinf
cont_recherche_mur_dY_obj:

        move.l adr_Y,a0
        move.l dec_Y,d3
        move.l pas_Y,d2
        move.l cos,d0
        move.l sin,d1
;;        tst.w d1   ;;deja fait par le move!!
        bgt recherche_mur_bcleYp_mur_obj_cont
        blt recherche_mur_bcleYn_mur_obj_cont

recherche_mur_distYinf:
        move.l #$FFFFFFFF,distY
        clr.b contY
        rts


recherche_mur:
;        bsr clear_colone
        bsr aff_weapon
        bsr calcsin
        bsr recherche_mur_dX
        bsr recherche_mur_dY
        bsr strmlineinit

; teste et affichage ...
recherche_mur_test_aff:
        move.l distM,d0
        cmp.l distX,d0
        bhi recherche_mur_affmur
        cmp.l distY,d0
        bhi recherche_mur_affbyY


recherche_mur_affstrm:
          cmp #$FFFFFFFF,d0
          beq recherche_mur_noaff
          tst d0
          beq recherche_mur_noaff  ; distance 0
; calcul de la texture
          move.l strmorder,a4
          move.w d6,d5
          sub.w oangle(a4),d5

          add.w #256,d5
          and.w #$1FF,d5
          sub.w #256,d5   ; d5 in ]-Pi,+Pi[

          muls #50,d5
          muls sdist+2(a4),d5
          swap.l d5         ; div 65536!!!
          ext.l d5

          add.l #8,d5
          cmp.l #16,d5
          bcc recherche_mur_affstrm_next ; hors de la texture
;          move.l d5,postM
;          move.l sdist(a4),distM ;deja fait
;          move.w stext(a4),textM
;fin calcul de la texture

          clr.l d1
          tst.w stxan(a4)
          bmi recherche_mur_affstrm_singletext

          move.w sangle(a4),d1
          add.w #32,d1
          add.w stxan(a4),d1
          lsr.w #6,d1
          and.w #7,d1

recherche_mur_affstrm_singletext:

          add.w stext(a4),d1   ; textM
          and.w #$1FF,d1
          lsl.l #8,d1
          add.l d5,d1  ; postM
          move.b #1,istransp
          lea textures_strm(pc),a1
          add.l d1,a1

          tst.b (a1)
          blt recherche_mur_affstrm_next ; colone vide

          lea strm_col,a5
          clr.w d1
          move.b actcol,d1
          lsl.w #2,d1
          add.w d1,a5
          move.l a4,(a5)  ; strm dans le tableau de colones (-> dgats)

          bsr zoomvertical
          tst.b istransp
          bne recherche_mur_aff
recherche_mur_affstrm_next:
                                ; take next, if end:
          move.l #$FFFFFFFF,distM
          bra recherche_mur_test_aff


recherche_mur_affmur:
        move.l distX,d0
        cmp.l distY,d0
        bhi recherche_mur_affbyY
recherche_mur_affbyX:
          cmp #$FFFFFFFF,d0
          beq recherche_mur_noaff
;          add.l #1,d0              ; decalage Z
          tst d0
          beq recherche_mur_noaff  ; distance 0
          clr.l d1
          move.w textX,d1
          and.w #$1FF,d1
          lsl.l #8,d1
          add.l postX,d1
          move.b #1,istransp
          lea textures_mur(pc),a1
          add.l d1,a1
          bsr zoomvertical

          tst.b contX
          beq recherche_mur_aff
          tst.b istransp
          bne recherche_mur_aff

          cmp.b #1,contX
          bne recherche_mur_affbyX_porte
          bsr cont_recherche_mur_dX_obj
          bra recherche_mur_test_aff

recherche_mur_affbyX_porte:
          bsr cont_recherche_mur_dX_porte
          bra recherche_mur_test_aff

recherche_mur_noaff:
        rts
recherche_mur_affbyY:
          move.l distY,d0
          cmp #$FFFFFFFF,d0
          beq recherche_mur_noaff
;          add.l #1,d0              ; decalage Z
          tst d0
          beq recherche_mur_noaff  ; distance 0
          clr.l d1
          move.w textY,d1
          and.w #$1FF,d1
          lsl.l #8,d1
          add.l postY,d1
          move.b #1,istransp
          lea textures_mur(pc),a1
          add.l d1,a1
          bsr zoomvertical

          tst.b contY
          beq recherche_mur_aff
          tst.b istransp
          bne recherche_mur_aff

          cmp.b #1,contY
          bne recherche_mur_affbyY_porte
          bsr cont_recherche_mur_dY_obj
          bra recherche_mur_test_aff

recherche_mur_affbyY_porte:
          bsr cont_recherche_mur_dY_porte
          bra recherche_mur_test_aff

recherche_mur_aff:
          move.l adresseecran,a2
          bsr affcolone
        rts


; in  :  d6 = angle
; out :  d1 = sin
;        d0 = cos
calcsin:
          and.w #$1FF,d6
          lea sin_tbl(pc),a0
          move.b 0(a0,d6.w),d1
          ext.w d1
          ext.l d1
          move.w d6,d2
          add.w #128,d2
          and.w #$1FF,d2
          move.b 0(a0,d2.w),d0
          ext.w d0
          ext.l d0
        rts

affichage:
        add.l #1,actcount
        bne affichage_nocountinit

        clr.l objcount   ;  il manque la boucle

        add.l #1,actcount
affichage_nocountinit:

        bsr strminit

        bsr affweaponspr

        lea sprites(pc),a3
        clr.b actcol
        move.l act_scr,adresseecran
        add.l #$A,adresseecran
        move.w pos_a,d6
        sub.w #40,d6
affichage_boucledec:
         move.l #24,d7
affichage_bouclestd:
          bsr recherche_mur
          add.w #1,d6
          add.b #1,actcol
          sub #8,d7
          bge affichage_bouclestd
          add.l #1,adresseecran
          cmp.b #80,actcol
          bne affichage_boucledec
        rts

effacement:
        move.l act_scr,a2
        add.l #$A,a2
        clr.l d0
        clr.l d1
        clr.l d2
        clr.l d3
        clr.l d4
        move.l #119,d5
effacement_bcle:
        movem d0-d4,(a2)
        movem d0-d4,10(a2)
        add #30,a2
        dbra d5,effacement_bcle

        rts

strminit:
        lea strm_col,a5
        move.l #79,d1
strminit_clrcol:
        clr.l (a5)+
        dbra d1,strminit_clrcol

        lea strmlist,a1
        bsr define_obj   ; calc the dist and the angle! as for obj!!!
                         ; make a loop...
        rts

strmlineinit:
        lea strmlist,a1
        move.l a1,strmorder
                         ; they must be shorted first
        move.l sdist(a1),distM
        rts

;*****************************************************
;       DATA
;*****************************************************

pos:
pos_x   dc.l $380
pos_y   dc.l $2E0
pos_a   dc.w $100

;structure des donnes de la carte:
;chaque mots (16 bits):
; general   *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
;          o/t type  donnes..............................
; objet:   o/t 0  0  numero d'obj dans la table suivante ( 0 = rien )
; mur:     o/t 0  1  numero de texture pour le mur .......
; porte    o/t 1 H/I type ouverture clef  texture.... texture mur lateral
;   porte |<-| |->|  0  0 ouverture clef  texture.... texture mur lateral
;   porte |<---|  |  1  1 ouverture clef  texture.... texture mur lateral
;   porte |  |--->|  1  0 ouverture clef  texture.... texture mur lateral
;  "porte"  fixe!    0  1 texture.................... texture mur lateral
;
;  o/t : 1=obstacle  , 0=traversable
;
;  H/I : 1=H  ,0=I   orientation de la porte vue de dessus sur la carte
;
;  clef: 0=normal 1,2,3 overte avec la clef 1,2,3 !
;
;  textures de mur = toute la liste !
;  textures de mur lat =  partir de "textures_murlat"
;  textures de porte =  partir de "textures_porte"
;  textures d'objet = toute la liste !


map:
	dc.w $A000,$A000,$A000,$A000,$A000,$A000,$A000,$A000,$A000,$A001,$A005,$A001,$A002,$A002,$A002,$A002
	dc.w $A000,$0001,$0000,$0000,$D889,$0000,$0000,$8004,$A000,$0000,$0000,$0000,$A002,$0000,$8002,$A002
	dc.w $A000,$0000,$0000,$0000,$D089,$0000,$0000,$0000,$A000,$A000,$2000,$A000,$A002,$0000,$0000,$A002
	dc.w $A000,$F009,$F809,$A000,$A000,$A000,$0000,$0000,$A000,$0000,$0000,$0000,$A002,$0003,$0000,$A002
	dc.w $A000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$A000,$0000,$A000,$0000,$A002,$0000,$0000,$A002
	dc.w $A000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$A000,$0000,$A000,$0000,$A002,$A002,$E0C5,$A002
	dc.w $A000,$F040,$A001,$E005,$A001,$A001,$A001,$0000,$A000,$0000,$A000,$0000,$0000,$0000,$0000,$A003
	dc.w $A000,$0000,$A001,$0000,$0000,$0000,$A001,$0000,$A000,$0000,$A000,$A003,$0000,$A003,$0000,$A003
	dc.w $A000,$0000,$A001,$0000,$0000,$0000,$A001,$0000,$0000,$0000,$0000,$A003,$0000,$A003,$0000,$A003
	dc.w $A000,$0000,$A001,$A001,$A001,$E005,$A001,$A000,$A000,$A000,$0000,$A003,$0000,$A003,$0000,$A003
	dc.w $A000,$0000,$D040,$0000,$0000,$0000,$0000,$0000,$0000,$D000,$0000,$A003,$0000,$A003,$0000,$A003
	dc.w $A000,$0000,$A000,$A000,$A000,$A000,$A000,$A000,$A000,$A000,$0000,$A003,$0000,$A003,$0000,$A003
	dc.w $A000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$A000,$0000,$0000,$0000,$0000,$0000,$A003
	dc.w $A000,$0000,$0000,$A001,$E810,$E810,$A001,$A001,$0005,$A000,$E80C,$E80C,$E80C,$E80C,$E80C,$A003
	dc.w $A000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$2000,$0000,$0000,$0000,$0000,$0000,$A003
	dc.w $A000,$A000,$A000,$A000,$A000,$A000,$A000,$A000,$A000,$A000,$A003,$A003,$A003,$A003,$A003,$A003


textures:
textures_mur:
 include textures\murclas1.inc
 include textures\murht1.inc
 include textures\murtemp1.inc
 include textures\murtemp2.inc

textures_murlat:
 include textures\murport1.inc
;;textmur equ 3  ; ((textures_murlat-textures_mur)/256)-1
textmur equ ((textures_murlat-textures)/256)-1

textures_porte:
textporte equ (textures_porte-textures_mur)/256
 include textures\portcha1.inc
 include textures\portht1.inc
 include textures\grille1.inc
 include textures\grille3.inc
 include textures\muret.inc

textures_obj:
 include textures\colone1.inc
 include textures\clef1.inc
 include textures\clef2.inc
 include textures\keycard.inc
textures_strm:
textstrm equ (textures_strm-textures_mur)/256
 include textures\skull.inc
 include textures\skull2.inc



sprites dc.b $00,$02,$01,$02,$01,$03,$03,$03
        dc.b $00,$08,$04,$08,$04,$0C,$0C,$0C
        dc.b $00,$20,$10,$20,$10,$30,$30,$30
        dc.b $00,$80,$40,$80,$40,$C0,$C0,$C0

sin_tbl:
        include sintbl.inc

atn_tbl:
        include atntbl.inc

actcount dc.l 0

objlist:
objdist  dc.l 0
objangle dc.w 0
objtext  dc.w 11
objposx  dc.l $180
objposy  dc.l $180
objcount dc.l 0
objactif dc.w $C001
objicon  dc.w $0000
objlistf:
         dc.l 0,10,$E80,$180,0,$0
         dc.l 0,12,$D80,$380,0,$C0020001
         dc.l 0,10,$780,$180,0,$0
         dc.l 0,13,$880,$D80,0,$C0030002


oposx  equ (objposx-objlist)
oposy  equ (objposy-objlist)
otext  equ (objtext-objlist)

odist  equ (objdist-objlist)
oangle equ (objangle-objlist)
ocount equ (objcount-objlist)
oactif equ (objactif-objlist)
oicon equ (objicon-objlist)
osize equ (objlistf-objlist)

strmlist:
strmdist  dc.l 0            ; dans le mme ordre et la mme position
strmangle dc.w 0            ; que pour les obj
strmtext  dc.w 0            ; car la routine de calcul de distance
strmposx  dc.l $280         ; et d'angle est la mme !
strmposy  dc.l $200         ; economie?
strmcount dc.l 0            ; a conserve mme si inutile car modifi!
strmtxan  dc.w $80          ; bit 15: 1=1vue, bit 14: dead, bits 9..0 : angle
strmlive  dc.w 30
strmtype  dc.b 0
strmetat  dc.b 0            ; stop | move | att | dead | 4bit count
strmmv_a  dc.w 0
strmmv_d  dc.l 0

strmlistf:

sposx  equ (strmposx-strmlist)  ;
sposy  equ (strmposy-strmlist)  ;
stext  equ (strmtext-strmlist)  ;
sdist  equ (strmdist-strmlist)  ;
sangle equ (strmangle-strmlist) ;
stxan  equ (strmtxan-strmlist)
slive  equ (strmlive-strmlist)
ssize  equ (strmlistf-strmlist)

strmorder dc.l 0,0

actweapon_m dc.l 0
actweapon_s dc.l 0

;*****************************************************
	BSS
;*****************************************************

adresseecran dc.l 0

; recherche de mur  ...
textX  dc.w 0
postX  dc.l 0
distX  dc.l 0

contX  dc.l 0
adr_X  dc.l 0  ; a0
dec_X  dc.l 0  ; d3
pas_X  dc.l 0  ; d2


textY  dc.w 0
postY  dc.l 0
distY  dc.l 0

contY  dc.l 0
adr_Y  dc.l 0  ; a0
dec_Y  dc.l 0  ; d3
pas_Y  dc.l 0  ; d2

sin    dc.l 0  ; d1
cos    dc.l 0  ; d0

; recherche de strum  ...
distM  dc.l 0

strm_col dcb.l 80,0


colone  dcb.b 62,0

istransp  dc.b 0
actcol dc.b 0

;*****************************************************
       END
