; World in 3D -- a ray caster engine for Ti-92
; Copyright (C) 1998-1999 Silicone <Julien.Viard@enst.fr>
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


;  routines de gestion de World in 3D V0.33Beta

        xdef init_invetory

        xdef testwall
        xdef test_obj_porte
        xdef test_fire

        xdef playstrm

; def pour les obj non dynamique // aff car non pulic
; !!! a modifier en cas de changement !!!

oposx   equ      8
oposy   equ      12
oactif  equ      20
oicon   equ      22
osize   equ      24

; idem pour les strm
sdist   equ      0
sangle  equ      4
stext   equ      6
sposx   equ      8
sposy   equ      12
stxan   equ      20
slive   equ      22
stype   equ      24
setat   equ      25
smv_a   equ      26
smv_d   equ      28
ssize   equ      32

;


testwall:
;test de dpassement!
; in
; d4= posx+decal
; d5= posy+decal
; out
; a0= adr case on!

; de carte
	cmp.l	#$102,d4
	bcc	noxinf
	move.l	#$102,d4
noxinf:
	cmp.l	#$efd,d4
	bcs	noxsup
	move.l	#$efd,d4
noxsup:
	cmp.l	#$102,d5
	bcc	noyinf
	move.l	#$102,d5
noyinf:
	cmp.l	#$efd,d5
	bcs	noysup
	move.l	#$efd,d5
noysup:


; de mur
        lea 	map,a0
	move.l 	pos_x,d0
	clr.b 	d0	; clear the low byte only !!!
	move.l 	pos_y,d1
	clr.b 	d1 
	move.l 	d0,d2
	lsr.l 	#7,d2
	add.l 	d2,a0
	move.l 	d1,d2
	lsr.l 	#3,d2
	add.l 	d2,a0  ; a0 -> the square you are on !!!

	move.w 	(a0),d3
	bpl	notonsth  ; ne bloque pas
        btst.w  #14,d3    ; est-ce une porte
	beq	notonsth  ; non
        btst.w  #13,d3    ; type de porte H/I !!
        beq     onporteI
onporteH:
        move.l  pos_y,d2
        and.l   #$FF,d2
        cmp.l   #$80,d2
        ble     porteHsup
porteHinf:
	move.l	d1,d2
	add.l 	#$A0,d2
	cmp.l	d2,d5
	bcc	notonsth
	move.l	d2,d5
        bra notonsth
porteHsup:
        move.l  d1,d2
	add.l	#$60,d2
	cmp.l	d2,d5
	bcs	notonsth
	move.l	d2,d5
        bra notonsth
onporteI:
        move.l  pos_x,d2
        and.l   #$FF,d2
        cmp.l   #$80,d2
        ble     porteIsup
porteIinf:
	move.l	d0,d2
	add.l 	#$A0,d2
	cmp.l	d2,d4
	bcc	notonsth
	move.l	d2,d4
        bra notonsth
porteIsup:
        move.l  d0,d2
	add.l	#$60,d2
	cmp.l	d2,d4
	bcs	notonsth
	move.l	d2,d4
notonsth:

	move.w 	-2(a0),d3
	bpl	nowallxinf ; ne bloque pas
        btst.w  #14,d3     ; est-ce une porte
        bne	nowallxinf ; oui
	move.l 	d0,d2
        btst.w  #14,d3     ; est-ce un obj
        bne	objxinf    ; oui
	add.l 	#20,d2
objxinf:
	cmp.l	d2,d4
	bcc	nowallxinf
	move.l	d2,d4
nowallxinf:

	move.w	+2(a0),d3
	bpl	nowallxsup ; ne bloque pas
        btst.w  #14,d3     ; est-ce une porte
        bne	nowallxsup ; oui
	move.l	d0,d2
	add.l	#$E0,d2
        btst.w  #14,d3     ; est-ce un obj
        beq	noobjxsup  ; non
	add.l 	#20,d2
noobjxsup:
	cmp.l	d2,d4
	bcs	nowallxsup
	move.l	d2,d4
nowallxsup:

	move.w 	-32(a0),d3
	bpl	nowallyinf ; ne bloque pas
        btst.w  #14,d3     ; est-ce une porte
        bne	nowallyinf ; oui
	move.l	d1,d2
        btst.w  #14,d3     ; est-ce un obj
        bne	objyinf    ; oui
	add.l 	#20,d2
objyinf:
	cmp.l	d2,d5
	bcc	nowallyinf
	move.l	d2,d5
nowallyinf:

	move.w	+32(a0),d3
	bpl	nowallysup; ne bloque pas
        btst.w  #14,d3     ; est-ce une porte
        bne	nowallysup ; oui
	move.l	d1,d2
	add.l	#$E0,d2
        btst.w  #14,d3     ; est-ce un obj
        beq	noobjysup  ; non
	add.l 	#20,d2
noobjysup:
	cmp.l	d2,d5
	bcs	nowallysup
	move.l	d2,d5
nowallysup:


        lea 	map,a0
	move.l 	d4,d0
	clr.b 	d0	; clear the low byte only !
	move.l 	d5,d1
	clr.b 	d1
	move.l 	d0,d2
	lsr.l 	#7,d2
	add.l 	d2,a0
	move.l 	d1,d2
	lsr.l 	#3,d2
	add.l 	d2,a0  ; a0 -> the square you will by on !
        move.b  (a0),d2
        and.b   #$C0,d2
        cmp.b   #$80,d2
        beq     walltestnook  ; on arrive sur un obj ou un mur qui bloque !

; ok
walltestok:
        move.l  d4,pos_x
        move.l  d5,pos_y
walltestnook:

        rts

test_obj_porte:

        lea 	map,a0
	move.l 	pos_x,d0
	clr.b 	d0	; clear the low byte only !!!
	move.l 	pos_y,d1
	clr.b 	d1 
	move.l 	d0,d2
	lsr.l 	#7,d2
	add.l 	d2,a0
	move.l 	d1,d2
	lsr.l 	#3,d2
	add.l 	d2,a0  ; a0 -> the square you are on !!!

        move.b (a0),d2
        and.b #$60,d2
        bne testporte  ; not an object ...
        move.w (a0),d2
        and.w #$1FFF,d2
        beq testporte  ; no object (0)...

        subq #1,d2
        and.w #$1FFF,d2
        mulu.w #osize,d2
        lea objlist,a1
        add.w d2,a1

        move.w oactif(a1),d2
        bpl testporte  ; no activity ...

        btst.w #14,d2
        beq testobj_noget
        clr.w (a0)  ; take it. so clear it !
testobj_noget:
        and.w #$3FFF,d2  ; numero d'activit
        beq testporte  ;  inactif (0)

        cmp.w #4,d2
        bge testobj_nokey
        ; c'est une clef !
        lea keylist,a1
        move.b #$FF,0(a1,d2)

        move.w #900,d3
        add.w d2,d3
        sub.w #1,d2
        add.w d2,d3
        move.w d3,-(sp)
        move.w d2,-(sp)
        move.l scr_offset,a2
        add.w d3,a2
        bsr aff_item
        move.w (sp)+,d2
        move.w (sp)+,d3
        move.l scr_offset+4,a2
        add.w d3,a2
        bsr aff_item

testobj_nokey:

testporte:
        tst.b porteactiv
        bne moveporte

        tst.b k_opendoor   ; on essai d'ouvrir ?
        beq testportefin
        clr.b k_opendoor

        btst.w #14,(a0)   ; 'y a une porte?
        beq testporte2
        move.b (a0),d2
        and.b #$18,d2
        cmp.b #$08,d2
        beq testportefin  ; elle ne s'ouvre pas!

        move.w (a0),d2
        lsr.b #6,d2
        and.w #$3,d2
        lea keylist,a1
        tst.b 0(a1,d2.w)
        beq testportefin  ; pas la clef !!

        move.l a0,porteadr
        move.b #1,porteactiv  ; ouvre
        move.b #7,portefinpos ; pos finale de la porte
        move.b (a0),portepos
        bmi testporteouvre
        neg.b porteactiv  ; non ferme!
        clr.b portefinpos ; pos finale de la porte
testporteouvre:
        and.b #7,portepos
        bra moveporte

testporte2:
        move.w pos_a,d6
        jsr calcsin  ; d1 = sin;  d0 = cos ; *128

        lea 	map,a0
	add.l 	pos_x,d0
	clr.b 	d0	; clear the low byte only !!!
	add.l 	pos_y,d1
	clr.b 	d1
	move.l 	d0,d2
	lsr.l 	#7,d2
	add.l 	d2,a0
	move.l 	d1,d2
	lsr.l 	#3,d2
	add.l 	d2,a0  ; a0 -> the square you are on !!!

        btst.w #14,(a0)   ; 'y a une porte?
        beq testportefin
        move.b (a0),d2
        and.b #$18,d2
        cmp.b #$08,d2
        beq testportefin  ; elle ne s'ouvre pas!

        move.w (a0),d2
        lsr.b #6,d2
        and.w #$3,d2
        lea keylist,a1
        tst.b 0(a1,d2.w)
        beq testportefin  ; pas la clef !!


        move.l a0,porteadr
        move.b #1,porteactiv  ; ouvre
        move.b #7,portefinpos ; pos finale de la porte
        move.b (a0),portepos
        bmi testporteouvre2
        neg.b porteactiv  ; non ferme!
        clr.b portefinpos ; pos finale de la porte
testporteouvre2:
        and.b #7,portepos

moveporte:
        move.b portepos,d4
        add.b porteactiv,d4
        and.b #7,d4
        cmp.b portefinpos,d4
        bne moveportecont
        clr.b porteactiv

moveportecont:
        move.b d4,portepos

        move.l porteadr,a0 ; porte ...
        move.b (a0),d2
        and.b #$78,d2  ; clear pos bits
        add.b d4,d2
        btst.b #2,d4
        bne moveportepasse
        tas d2    ; set bit 7 of d3 , a bloque...
moveportepasse:
        move.b d2,(a0)


testportefin:
        rts

test_fire:
        tst.b on_fire
        bne test_fire_on
        tst.b k_fire
        bne test_fire_start

        lea weapon1,a1  ; par defaut
        move.l a1,a2
        add.l (a1),a2
        move.l a1,a3
        add.l (a2),a3
        move.l a3,actweapon_m

        move.l a1,a3
        add.l 4(a2),a3
        move.l a3,actweapon_s
        rts

test_fire_start:
        move.b #1,on_fire
        move.l #8,fire_activ
test_fire_on:
        move.l fire_activ,d2
        lea weapon1,a1
        move.b 0(a1,d2),d0
        move.b d0,d1                                   ; dessin
        and.l #$3C,d1
        add.b d1,d1
        move.l a1,a2
        add.l (a1),a2
        move.l a1,a3
        add.l 0(a2,d1),a3
        move.l a3,actweapon_m
        move.l a1,a3
        add.l 4(a2,d1),a3
        move.l a3,actweapon_s
        clr.l d1
        move.b d0,d1                                   ; degats
        and.b #$C0,d1
        cmp.b #$C0,d1
        beq test_fire_no_degats
        mulu #5,d1
        move.l a1,a2
        add.l 4(a1),a2
        add.w d1,a2        ; a2 -> profil de degats
        lea strm_col,a3
        clr.l d1
test_fire_degats_bcle:
        move.l 0(a3,d1),d3
        beq test_fire_degats_bcle_f ; pas de strm
        move.l d3,a4
        tst.w slive(a4)
        bmi test_fire_degats_bcle_f ; deja mort!
        move.w 0(a2,d1),d3
        ext.l d3
        cmp.l sdist(a4),d3
        bls test_fire_degats_bcle_f ; trop court!
        move.w 2(a2,d1),d3
        sub.w d3,slive(a4)

test_fire_degats_bcle_f:
        add.l #4,d1
        cmp.l #320,d1
        bne test_fire_degats_bcle

test_fire_no_degats:

        move.b d0,d1                                   ; activit
        and.b #$3,d1
        cmp.b #31,fire_count                   ; compteur
        beq test_fire_set_count
        tst.b fire_count
        beq test_fire_no_set_count
        sub.b #1,fire_count
        bra test_fire_no_set_count
test_fire_set_count:
        btst.b #1,d1
        bne test_fire_no_set_count
        move.b 1(a1,d2),d2
        and.b #$1F,d2
        move.b d2,fire_count
test_fire_no_set_count:

        cmp.b #3,d1                     ;fin de la sequence
        bne test_fire_no_fin
;        clr.b on_fire
;        clr.b fire_count
        clr.w on_fire   ; car fire_count est aprs on_fire ... 2 d'un coup!
        move.b #31,fire_count
        rts
test_fire_no_fin:

        tst.b d1                        ;rien / attendre n
        bne test_fire_no_0
        tst.b fire_count                   ; compteur
        beq test_fire_jump
        rts
test_fire_no_0:

        cmp.b #1,d1                     ;reste tant que non lach +saut si>n
        bne test_fire_no_1
        tst.b k_fire
        bne test_fire_1
        tst.b fire_count
        beq test_fire_cont
test_fire_jump:
        move.b 1(a1,d2),d2
        and.b #$E0,d2
        lsr.b #4,d2
        ext.w d2
        ext.l d2
        add.l #2,d2
        add.l d2,fire_activ
        move.b #31,fire_count
test_fire_1:
        rts
test_fire_no_1:

       ; d1=2 !!                        ; saut si relach continu sinon
        tst.b k_fire
        beq test_fire_jump

test_fire_cont:
        add.l #2,fire_activ
        move.b #31,fire_count 
        rts



aff_item:
; in d2:icon number, a2:screen position
; change : a3, d2, a2
        lea iconlist,a3
        lsl.w #3,d2
        add.w d2,a3
        move.l #7,d2
aff_item_bcle:
        move.b (a3)+,(a2)
        add.w #30,a2
        dbra d2,aff_item_bcle
        rts

; d2:icon d3:pos
aff_life_icon:
          move.w d2,-(sp)
          move.w d3,-(sp)
          move.l scr_offset,a2
          add.w d3,a2
          bsr aff_item
          move.w (sp),d3
          move.w 2(sp),d2
          move.l scr_offset+4,a2
          add.w d3,a2
          bsr aff_item
          move.w (sp)+,d3
          move.w (sp)+,d2
          rts

aff_life:
          move.w #600,d3
          clr.l d0
          move.b life,d0
          move.l d0,d5
          lsr.b #2,d0
          clr.l d1
          move.b lifemax,d1
          lsr.b #2,d1
          sub.l d0,d1
          sub.l #1,d0
          bmi aff_life_part
          move.w #7,d2
aff_life_4bcle:
           bsr aff_life_icon
           add.w #1,d3
          dbra d0,aff_life_4bcle
aff_life_part:
          sub.l #1,d1
          bmi aff_life_no0

          and.b #3,d5
          add.b #3,d5
          move.b d5,d2
          bsr aff_life_icon
          add.w #1,d3

          move.b #3,d2
          sub.l #1,d1
          bmi aff_life_no0
aff_life_0bcle:
           bsr aff_life_icon
           add.w #1,d3
          dbra d1,aff_life_0bcle
aff_life_no0:
        rts

init_invetory:
        move.l #1,d1
        lea keylist,a1
init_invetory_bcle:
         tst.b 0(a1,d1)
         beq init_invetory_noaff
          move.w d1,d2

          move.w #900,d3
          add.w d2,d3
          sub.w #1,d2
          add.w d2,d3
          move.w d3,-(sp)
          move.w d2,-(sp)
          move.l scr_offset,a2
          add.w d3,a2
          bsr aff_item
          move.w (sp)+,d2
          move.w (sp)+,d3
          move.l scr_offset+4,a2
          add.w d3,a2
          bsr aff_item
init_invetory_noaff:
         add.l #1,d1
         cmp.b #4,d1
        bne init_invetory_bcle

; init lifecounter
        bsr aff_life
;

; init weapon
        lea weapon1,a1
        move.l a1,a2
        add.l (a1),a2
        add.l (a2),a1
        move.l a1,actweapon_m

        lea weapon1,a1
        move.l a1,a2
        add.l (a1),a2
        add.l 4(a2),a1
        move.l a1,actweapon_s

;        clr.b on_fire
;        clr.b fire_count
        clr.w on_fire   ; car fire_count est aprs on_fire ... 2 d'un coup!
        move.b #31,fire_count

        rts

playstrm_objdist
	movem.l	d0-d1,-(sp)

        move.l oposx(a2),d0
        sub.l sposx(a0),d0
        bpl playstrm_objdist_dxpos
        neg.l d0
playstrm_objdist_dxpos:

        move.l oposy(a2),d1
        sub.l sposy(a0),d1
        bpl playstrm_objdist_dypos
        neg.l d1
playstrm_objdist_dypos:

	mulu.w		d0,d0
	mulu.w		d1,d1
	add.l		d0,d1		;d1=x^2+y^2

	moveq		#1,d0		;Odd number counter
	moveq		#-1,d4		;Returned value

\loop	sub.l		d0,d1
	addq.l		#2,d0
	addq.l		#1,d4
	tst.l		d1
	bge.s		\loop

	movem.l	(sp)+,d0-d1
        rts

playstrm:
        lea strmlist,a0

        clr.l d0
        move.b stype(a0),d0
        mulu #stsize,d0
        lea strmtypelist,a5
        add.l d0,a5

        move.w slive(a0),d0
        tst.w d0
        bgt playstrm_alive
        btst.b #4,setat(a0)
        bne playstrm_dead1
        move.w #$8000,stxan(a0)
        move.b #$10,setat(a0)

playstrm_dead1:
        clr.l d0
        move.b setat(a0),d0
        and.b #$f,d0
        clr.l d1
        move.b sttxdd(a5,d0),d1
        move.w d1,stext(a0) ; texture

        cmp.b #$1F,setat(a0)
        beq playstrm_dead2
        add.b #1,setat(a0)
        bra playstrm_fin

playstrm_dead2:
  ;       effacer!

        bra playstrm_fin
playstrm_alive:

        btst.b #5,setat(a0)    ; mode attaque ! (c'est une sequence qui se dsactive d'elle mme)
        bne playstrm_att

        move.w sangle(a0),d6 ; angle
        add.w #$100,d6
        move.l a0,-(sp)
        jsr calcsin         ; d0=cos d1=sin
        move.l (sp)+,a0
; recherche de mur sur X
playstrm_mur_dX:
        tst.w d0
        beq playstrm_mur_distXinf 
        ble playstrm_mur_dXneg
playstrm_mur_dXpos:
          move.l d1,d2
          asl.l #8,d2
          divs d0,d2
          bvs playstrm_mur_distXinf
          ext.l d2
          move.l sposx(a0),d3
          lsr.l #7,d3
          and.l #$1E,d3
          lea map,a1
          add.l d3,a1         ; map + c
          move.l sposx(a0),d3
          and.l #$ff,d3
          muls d2,d3
          neg.l d3 
          asr.l #8,d3
          add.l sposy(a0),d3      ; yd
          add.l d3,d3         ; *2
playstrm_mur_bcleXptq:
            move.l d3,d4
            lsr.l #4,d4
            and.l #$1E0,d4
            tst.w 0(a1,d4)
            beq playstrm_mur_bcleXp_mur_obj_cont
            btst.w #14,0(a1,d4)
            beq playstrm_trouv_mur_obj_Xp
playstrm_mur_bcleXp_mur_obj_cont:
            add.l d2,d3
            cmp #$1FFF,d3
            bgt playstrm_mur_distXinf
            move.l d3,d4
            lsr.l #4,d4
            and.l #$1E0,d4
            btst.w #14,0(a1,d4)
            beq playstrm_mur_bcleXp_porte_cont
            btst.w #13,0(a1,d4)
            beq playstrm_trouv_porte_Xp_I
playstrm_mur_bcleXp_porte_cont:
            add.l #2,a1
            add.l d2,d3
            cmp #$1FFF,d3
            ble playstrm_mur_bcleXptq
            bra playstrm_mur_distXinf

playstrm_trouv_mur_obj_Xp:
            btst.w #13,0(a1,d4)
            beq playstrm_trouv_obj_X
playstrm_trouv_mur_Xp:
          lea map,a2
          move.l a1,d4
          sub.l a2,d4
          asl.l #7,d4
          sub.l sposx(a0),d4
          asl.l #7,d4
          divs d0,d4
          bvs playstrm_mur_distXinf ;???
          ext.l d4          ; distance
          ble playstrm_mur_bcleXp_mur_obj_cont ; distance negative ou nulle !

          bra playstrm_trouv_dist_test_X

playstrm_trouv_obj_X:
          move.w 0(a1,d4),d5
          subq #1,d5
          and.w #$1FFF,d5
          mulu.w #osize,d5
          lea objlist,a2
          add.w d5,a2

          jsr playstrm_objdist     ; d4=dist

          bra playstrm_trouv_dist_test_X

playstrm_trouv_porte_Xp_I:
          move.b 0(a1,d4),d5  ;type
          and.b #$18,d5    ;type de porte
          cmp.b #$8,d5     ;porte fixe
          beq playstrm_trouv_porte_Xp_I_ok
          move.b 0(a1,d4),d5  ;type
          and.b #$7,d5     ;ouverture
          cmp.b #$7,d5     ; ouverte ?
          beq playstrm_mur_bcleXp_porte_cont
playstrm_trouv_porte_Xp_I_ok:
          lea map,a2
          move.l a1,d4
          add.l #1,d4       ; case + 1/2
          sub.l a2,d4
          asl.l #7,d4
          sub.l sposx(a0),d4
          asl.l #7,d4
          divs d0,d4
          bvs playstrm_mur_distXinf ;???
          ext.l d4
          ble playstrm_mur_bcleXp_porte_cont ; distance negative !
          bra playstrm_trouv_dist_test_X

playstrm_mur_dXneg:
          move.l d1,d2
          asl.l #8,d2
          divs d0,d2
          bvs playstrm_mur_distXinf
          ext.l d2
          move.l sposx(a0),d3
          sub.l #1,d3
          lsr.l #7,d3
          and.l #$1E,d3
          lea map,a1
          add.l d3,a1         ; map + c
          move.l sposx(a0),d3
          neg.l d3
          and.l #$ff,d3
          muls d2,d3
          asr.l #8,d3
          add.l sposy(a0),d3      ; yd
          add.l d3,d3         ; *2
playstrm_mur_bcleXntq:
            move.l d3,d4
            lsr.l #4,d4
            and.l #$1E0,d4
            tst.w 0(a1,d4)
            beq playstrm_mur_bcleXn_mur_obj_cont
            btst.w #14,0(a1,d4)
            beq playstrm_trouv_mur_obj_Xn
playstrm_mur_bcleXn_mur_obj_cont:
            sub.l d2,d3
            cmp #$1FFF,d3
            bgt playstrm_mur_distXinf
            move.l d3,d4
            lsr.l #4,d4
            and.l #$1E0,d4
            btst.w #14,0(a1,d4)
            beq playstrm_mur_bcleXn_porte_cont
            btst.w #13,0(a1,d4)
            beq playstrm_trouv_porte_Xn_I
playstrm_mur_bcleXn_porte_cont:
            sub.l #2,a1
            sub.l d2,d3
            cmp #$1FFF,d3
            ble playstrm_mur_bcleXptq
            bra playstrm_mur_distXinf

playstrm_trouv_mur_obj_Xn:
            btst.w #13,0(a1,d4)
            beq playstrm_trouv_obj_X
playstrm_trouv_mur_Xn:
          lea map,a2
          move.l a1,d4
          sub.l a2,d4
          add.l #2,d4
          asl.l #7,d4
          sub.l sposx(a0),d4
          asl.l #7,d4
          divs d0,d4
          bvs playstrm_mur_distXinf ;???
          ext.l d4          ; distance
          ble playstrm_mur_bcleXn_mur_obj_cont ; distance negative ou nulle !

          bra playstrm_trouv_dist_test_X


playstrm_trouv_porte_Xn_I:
          move.b 0(a1,d4),d5  ;type
          and.b #$18,d5    ;type de porte
          cmp.b #$8,d5     ;porte fixe
          beq playstrm_trouv_porte_Xn_I_ok
          move.b 0(a1,d4),d5  ;type
          and.b #$7,d5     ;ouverture
          cmp.b #$7,d5     ; ouverte ?
          beq playstrm_mur_bcleXn_porte_cont
playstrm_trouv_porte_Xn_I_ok:
          lea map,a2
          move.l a1,d4
          add.l #1,d4       ; case + 1/2
          sub.l a2,d4
          asl.l #7,d4
          sub.l sposx(a0),d4
          add.l #2,d4
          asl.l #7,d4
          divs d0,d4
          bvs playstrm_mur_distXinf ;???
          ext.l d4
          ble playstrm_mur_bcleXp_porte_cont ; distance negative !
;          bra playstrm_trouv_dist_test_X

playstrm_trouv_dist_test_X:
          cmp.l sdist(a0),d4
          ble playstrm_out_of_detect  ; interference !
playstrm_mur_distXinf:

; recherche de mur sur Y
playstrm_mur_dY:
        tst.w d1
        beq playstrm_mur_distYinf
        ble playstrm_mur_dYneg
playstrm_mur_dYpos:
          move.l d0,d2
          asl.l #8,d2
          divs d1,d2
          bvs playstrm_mur_distXinf
          ext.l d2
          move.l sposy(a0),d3
          lsr.l #3,d3
          and.l #$1E0,d3
          lea map,a1
          add.l d3,a1         ; map + l
          move.l sposy(a0),d3
          and.l #$ff,d3
          muls d2,d3
          neg.l d3 
          asr.l #8,d3
          add.l sposx(a0),d3      ; xd
          add.l d3,d3         ; *2
playstrm_mur_bcleYptq:
            move.l d3,d4
            lsr.l #8,d4
            and.l #$1E,d4
            tst.w 0(a1,d4)
            beq playstrm_mur_bcleYp_mur_obj_cont
            btst.w #14,0(a1,d4)
            beq playstrm_trouv_mur_obj_Yp
playstrm_mur_bcleYp_mur_obj_cont:
            add.l d2,d3
            cmp #$1FFF,d3
            bgt playstrm_mur_distYinf
            move.l d3,d4
            lsr.l #8,d4
            and.l #$1E,d4
            btst.w #14,0(a1,d4)
            beq playstrm_mur_bcleYp_porte_cont
            btst.w #13,0(a1,d4)
            bne playstrm_trouv_porte_Yp_H
playstrm_mur_bcleYp_porte_cont:
            add.l #32,a1
            add.l d2,d3
            cmp #$1FFF,d3
            ble playstrm_mur_bcleYptq
            bra playstrm_mur_distYinf

playstrm_trouv_mur_obj_Yp:
            btst.w #13,0(a1,d4)
            beq playstrm_trouv_obj_Y
playstrm_trouv_mur_Yp:
          lea map,a2
          move.l a1,d4
          sub.l a2,d4
          asl.l #3,d4
          sub.l sposy(a0),d4
          asl.l #7,d4
          divs d1,d4
          bvs playstrm_mur_distYinf ;???
          ext.l d4          ; distance
          ble playstrm_mur_bcleYp_mur_obj_cont ; distance negative ou nulle !

          bra playstrm_trouv_dist_test_Y

playstrm_trouv_obj_Y:
          move.w 0(a1,d4),d5
          subq #1,d5
          and.w #$1FFF,d5
          mulu.w #osize,d5
          lea objlist,a2
          add.w d5,a2

          jsr playstrm_objdist     ; d4=dist

          bra playstrm_trouv_dist_test_Y

playstrm_trouv_porte_Yp_H:
          move.b 0(a1,d4),d5  ;type
          and.b #$18,d5    ;type de porte
          cmp.b #$8,d5     ;porte fixe
          beq playstrm_trouv_porte_Yp_H_ok
          move.b 0(a1,d4),d5  ;type
          and.b #$7,d5     ;ouverture
          cmp.b #$7,d5     ; ouverte ?
          beq playstrm_mur_bcleYp_porte_cont
playstrm_trouv_porte_Yp_H_ok:
          lea map,a2
          move.l a1,d4
          add.l #16,d4       ; case + 1/2
          sub.l a2,d4
          asl.l #3,d4
          sub.l sposy(a0),d4
          asl.l #7,d4
          divs d1,d4
          bvs playstrm_mur_distYinf ;???
          ext.l d4
          ble playstrm_mur_bcleYp_porte_cont ; distance negative !
          bra playstrm_trouv_dist_test_Y

playstrm_mur_dYneg:
          move.l d0,d2
          asl.l #8,d2
          divs d1,d2
          bvs playstrm_mur_distYinf
          ext.l d2
          move.l sposy(a0),d3
          sub.l #1,d3
          lsr.l #3,d3
          and.l #$1E0,d3
          lea map,a1
          add.l d3,a1         ; map + l
          move.l sposy(a0),d3
          neg.l d3
          and.l #$ff,d3
          muls d2,d3
          asr.l #8,d3
          add.l sposx(a0),d3      ; xd
          add.l d3,d3         ; *2
playstrm_mur_bcleYntq:
            move.l d3,d4
            lsr.l #8,d4
            and.l #$1E,d4
            tst.w 0(a1,d4)
            beq playstrm_mur_bcleYn_mur_obj_cont
            btst.w #14,0(a1,d4)
            beq playstrm_trouv_mur_obj_Yn
playstrm_mur_bcleYn_mur_obj_cont:
            sub.l d2,d3
            cmp #$1FFF,d3
            bgt playstrm_mur_distYinf
            move.l d3,d4
            lsr.l #8,d4
            and.l #$1E,d4
            btst.w #14,0(a1,d4)
            beq playstrm_mur_bcleYn_porte_cont
            btst.w #13,0(a1,d4)
            bne playstrm_trouv_porte_Yn_H
playstrm_mur_bcleYn_porte_cont:
            sub.l #32,a1
            sub.l d2,d3
            cmp #$1FFF,d3
            ble playstrm_mur_bcleYptq
            bra playstrm_mur_distYinf

playstrm_trouv_mur_obj_Yn:
            btst.w #13,0(a1,d4)
            beq playstrm_trouv_obj_Y
playstrm_trouv_mur_Yn:
          lea map,a2
          move.l a1,d4
          sub.l a2,d4
          add.l #32,d4
          asl.l #3,d4
          sub.l sposy(a0),d4
          asl.l #7,d4
          divs d1,d4
          bvs playstrm_mur_distYinf ;???
          ext.l d4          ; distance
          ble playstrm_mur_bcleYn_mur_obj_cont ; distance negative ou nulle !

          bra playstrm_trouv_dist_test_Y


playstrm_trouv_porte_Yn_H:
          move.b 0(a1,d4),d5  ;type
          and.b #$18,d5    ;type de porte
          cmp.b #$8,d5     ;porte fixe
          beq playstrm_trouv_porte_Yn_H_ok
          move.b 0(a1,d4),d5  ;type
          and.b #$7,d5     ;ouverture
          cmp.b #$7,d5     ; ouverte ?
          beq playstrm_mur_bcleYn_porte_cont
playstrm_trouv_porte_Yn_H_ok:
          lea map,a2
          move.l a1,d4
          add.l #16,d4       ; case + 1/2
          sub.l a2,d4
          asl.l #3,d4
          sub.l sposy(a0),d4
          asl.l #7,d4
          divs d1,d4
          bvs playstrm_mur_distYinf ;???
          ext.l d4
          ble playstrm_mur_bcleXp_porte_cont ; distance negative !
;          bra playstrm_trouv_dist_test_Y

playstrm_trouv_dist_test_Y:
          cmp.l sdist(a0),d4
          ble playstrm_out_of_detect  ; interference !
playstrm_mur_distYinf:

        tst.b on_fire
        beq playstrm_test_vue
playstrm_test_ent:
        move.l stdent(a5),d0
        cmp.l sdist(a0),d0
        blt playstrm_out_of_detect
        bra playstrm_detected
playstrm_test_vue:
        move.l stdvue(a5),d0
        cmp.l sdist(a0),d0
        blt playstrm_out_of_detect

        move.w stxan(a0),d0
        add.w sangle(a0),d0
        add.w #$100,d0
        and.w #$1FF,d0
        sub.w #$100,d0

        cmp.w stavue(a5),d0
        bgt playstrm_out_of_detect
        neg d0
        cmp.w stavue(a5),d0
        bgt playstrm_out_of_detect
playstrm_detected:
        and.b #$3F,setat(a0)
        or.b #$40,setat(a0)
        move.l sdist(a0),smv_d(a0)
        move.l sangle(a0),smv_a(a0)
        add.w #$100,smv_a(a0)
        move.l stdatt(a5),d0
        cmp.l sdist(a0),d0
        blt playstrm_out_of_detect
        move.b #$20,setat(a0)    ; attaque
;        or.b #$20,setat(a0)    ; attaque

playstrm_out_of_detect:

        btst.b #5,setat(a0)
        beq playstrm_no_att
playstrm_att:
          clr.l d0
          move.b setat(a0),d0
          and.b #$f,d0
          clr.l d1
          move.b sttxat(a5,d0),d1
          tst.b d1
          bpl playstrm_att_nodegats
          move.l stdatt(a5),d2
          cmp.l sdist(a0),d2
          blt playstrm_att_nodegats  ; dist ?
          move.b stdamg(a5),d2
          move.b #1,damaged
          sub.b d2,life
          bge playstrm_att_nodegats
          clr.b life
playstrm_att_nodegats:
          and.b #$7f,d1
          move.w d1,stext(a0) ; texture
          move.w #$8000,stxan(a0)
          cmp.b #$f,d0
          beq playstrm_fin_att
          add.b #1,d0
          move.b sttxat(a5,d0),d1
          cmp.b #$ff,d1
          beq playstrm_fin_att
          or.b #$20,d0
          move.b d0,setat(a0)
          bra playstrm_fin

playstrm_fin_att:
          clr.b setat(a0)   ; clr etat pour finir l'att
          move smv_a(a0),d6
          move.w #$100,d2
          sub.w d6,d2
          and.w #$1FF,d2
          move.w d2,stxan(a0) ; angle de vue
          clr.l d2
          move.b sttxmv(a5),d2
          move.w d2,stext(a0) ; texture

          bra playstrm_fin
playstrm_no_att:

        btst.b #6,setat(a0)
        beq playstrm_no_move
playstrm_move:
          move smv_a(a0),d6
          move.l a0,-(sp)
          jsr calcsin         ; d0=cos d1=sin
          move.l (sp)+,a0
          move.w #$100,d2
          sub.w d6,d2
          and.w #$1FF,d2
          move.w d2,stxan(a0) ; angle de vue
          move.b setat(a0),d2
          add.b #1,d2
          and.b #$F1,d2
          move.b d2,setat(a0)
          and.l #1,d2
          move.b sttxmv(a5,d2),d2
          move.w d2,stext(a0) ; texture

          move.b stsco2(a5),d2
          asr.l d2,d0
          asr.l d2,d1
          move.l #$80,d6
          lsr.l d2,d6

          move.l sposx(a0),d4
          add.l d0,d4
          move.l sposy(a0),d5
          add.l d1,d5
; test de dpassement
; de carte
	cmp.l	#$102,d4
	bcc	playstrm_move_noxinf
	move.l	#$102,d4
playstrm_move_noxinf:
	cmp.l	#$efd,d4
	bcs	playstrm_move_noxsup
	move.l	#$efd,d4
playstrm_move_noxsup:
	cmp.l	#$102,d5
	bcc	playstrm_move_noyinf
	move.l	#$102,d5
playstrm_move_noyinf:
	cmp.l	#$efd,d5
	bcs	playstrm_move_noysup
	move.l	#$efd,d5
playstrm_move_noysup:


; de mur
        lea 	map,a1
	move.l 	sposx(a0),d0
	clr.b 	d0	; clear the low byte only !!!
	move.l 	sposy(a0),d1
	clr.b 	d1
	move.l 	d0,d2
	lsr.l 	#7,d2
	add.l 	d2,a1
	move.l 	d1,d2
	lsr.l 	#3,d2
	add.l 	d2,a1  ; a1 -> the square strm is on !!!

	move.w 	(a1),d3
	bpl	playstrm_move_notonsth  ; ne bloque pas
        btst.w  #14,d3    ; est-ce une porte
	beq	playstrm_move_notonsth  ; non
        btst.w  #13,d3    ; type de porte H/I !!
        beq     playstrm_move_onporteI
playstrm_move_onporteH:
        move.l  sposy(a0),d2
        and.l   #$FF,d2
        cmp.l   #$80,d2
        ble     playstrm_move_porteHsup
playstrm_move_porteHinf:
	move.l	d1,d2
	add.l 	#$A0,d2
	cmp.l	d2,d5
	bcc	playstrm_move_notonsth
	move.l	d2,d5
        bra playstrm_move_notonsth
playstrm_move_porteHsup:
        move.l  d1,d2
	add.l	#$60,d2
	cmp.l	d2,d5
	bcs	playstrm_move_notonsth
	move.l	d2,d5
        bra playstrm_move_notonsth
playstrm_move_onporteI:
        move.l  sposx(a0),d2
        and.l   #$FF,d2
        cmp.l   #$80,d2
        ble     playstrm_move_porteIsup
playstrm_move_porteIinf:
	move.l	d0,d2
	add.l 	#$A0,d2
	cmp.l	d2,d4
	bcc	playstrm_move_notonsth
	move.l	d2,d4
        bra playstrm_move_notonsth
playstrm_move_porteIsup:
        move.l  d0,d2
	add.l	#$60,d2
	cmp.l	d2,d4
	bcs	playstrm_move_notonsth
	move.l	d2,d4
playstrm_move_notonsth:

	move.w 	-2(a1),d3
	bpl	playstrm_move_nowallxinf ; ne bloque pas
        btst.w  #14,d3                   ; est-ce une porte
        bne	playstrm_move_nowallxinf ; oui
	move.l 	d0,d2
        btst.w  #14,d3                   ; est-ce un obj
        bne	playstrm_move_objxinf    ; oui
	add.l 	#20,d2
playstrm_move_objxinf:
	cmp.l	d2,d4
	bcc	playstrm_move_nowallxinf
	move.l	d2,d4
playstrm_move_nowallxinf:

	move.w	+2(a1),d3
	bpl	playstrm_move_nowallxsup ; ne bloque pas
        btst.w  #14,d3                   ; est-ce une porte
        bne	playstrm_move_nowallxsup ; oui
	move.l	d0,d2
	add.l	#$E0,d2
        btst.w  #14,d3                   ; est-ce un obj
        beq	playstrm_move_noobjxsup  ; non
	add.l 	#20,d2
playstrm_move_noobjxsup:
	cmp.l	d2,d4
	bcs	playstrm_move_nowallxsup
	move.l	d2,d4
playstrm_move_nowallxsup:

	move.w 	-32(a1),d3
	bpl	playstrm_move_nowallyinf ; ne bloque pas
        btst.w  #14,d3                   ; est-ce une porte
        bne	playstrm_move_nowallyinf ; oui
	move.l	d1,d2
        btst.w  #14,d3                   ; est-ce un obj
        bne	playstrm_move_objyinf    ; oui
	add.l 	#20,d2
playstrm_move_objyinf:
	cmp.l	d2,d5
	bcc	playstrm_move_nowallyinf
	move.l	d2,d5
playstrm_move_nowallyinf:

	move.w	+32(a1),d3
	bpl	playstrm_move_nowallysup ; ne bloque pas
        btst.w  #14,d3                   ; est-ce une porte
        bne	playstrm_move_nowallysup ; oui
	move.l	d1,d2
	add.l	#$E0,d2
        btst.w  #14,d3                   ; est-ce un obj
        beq	playstrm_move_noobjysup  ; non
	add.l 	#20,d2
playstrm_move_noobjysup:
	cmp.l	d2,d5
	bcs	playstrm_move_nowallysup
	move.l	d2,d5
playstrm_move_nowallysup:


        lea 	map,a1
	move.l 	d4,d0
	clr.b 	d0	; clear the low byte only !
	move.l 	d5,d1
	clr.b 	d1
	move.l 	d0,d2
	lsr.l 	#7,d2
	add.l 	d2,a1
	move.l 	d1,d2
	lsr.l 	#3,d2
	add.l 	d2,a1  ; a1 -> the square strm will be on !

	move.l 	sposx(a0),d0
	move.l 	sposy(a0),d1


        move.b  (a1),d2
        and.b   #$C0,d2
        cmp.b   #$80,d2
        beq     playstrm_move_stop  ; il arrive sur un obj ou un mur qui bloque !

; ok
playstrm_move_walltestok:
        move.l  d4,sposx(a0)
        move.l  d5,sposy(a0)
        sub.l d6,smv_d(a0)
        blt playstrm_move_stop

        cmp.l d0,d4
        bne playstrm_move_ok
        cmp.l d1,d5
        bne playstrm_move_ok
        bset.b #7,setat(a0)
        beq playstrm_move_ok ; first stop
playstrm_move_stop:
        bclr.b #6,setat(a0)

playstrm_move_ok:

playstrm_no_move:


playstrm_fin:
            ; make a loop if more than 1 strm


        tst.b damaged
        beq playstrm_not_damaged
        bsr aff_life
        clr.b damaged
playstrm_not_damaged
        rts

;*****************************************************
;       DATA
;*****************************************************

life    dc.b 16   ; <= lifemax
lifemax dc.b 20   ; multiple de 4  ; max 40


; liste des clef active dans le monde

keylist
       dc.b $FF ; on a toujours la clef 0 pour simuler l'inexistence de clef! pour les portes 0
       dc.b 0
       dc.b 0
       dc.b 0

; icones

iconlist
        include icones.inc

weapon1
        include weapon_h.inc

strmtypelist:
strmtypedistent  dc.l $1000
strmtypedistvue  dc.l $500
strmtypeanglevue dc.w $60
strmtypedistatt  dc.l $100
strmtypescoef2   dc.b 4
strmtypedamage   dc.b 1
strmtypetxmv     dc.b 0,0
strmtypetxatt    dc.b 0,$A,$8A,0,$FF,0,0,0,0,0,0,0,0,0,0,0
strmtypetxdead   dc.b 8,8,8,9,9,9,9,9,9,9,9,9,9,9,9,9
strmtypelistf:

stdent equ (strmtypedistent-strmtypelist)
stdvue equ (strmtypedistvue-strmtypelist)
stavue equ (strmtypeanglevue-strmtypelist)
stdatt equ (strmtypedistatt-strmtypelist)
stsco2 equ (strmtypescoef2-strmtypelist)
stdamg equ (strmtypedamage-strmtypelist)
sttxmv equ (strmtypetxmv-strmtypelist)
sttxat equ (strmtypetxatt-strmtypelist)
sttxdd equ (strmtypetxdead-strmtypelist)
stsize equ (strmtypelistf-strmtypelist)


; non rinit ... (on peut quitter alors qu'une porte bouge)
porteactiv
        dc.b 0 
portepos
        dc.b 0
portefinpos
        dc.b 0

        dc.b 0

porteadr
        dc.l 0

;*****************************************************
	BSS
;*****************************************************
;
on_fire
        dc.b 0
fire_count
        dc.b 0

fire_activ
        dc.l 0

damaged dc.b 0

        dc.b 0  ;align
;*****************************************************
       END
