program make_weapon_data;
{$G+}

(* World in 3D -- a ray caster engine for Ti-92
 * Copyright (C) 1998-1999 Silicone <Julien.Viard@enst.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *)

uses crt,graph16,ddir;

type
  t_pal_16=array[0..15,0..2] of byte;

  t_m=array[0..79,0..7] of byte;

function testligne(l:integer;p:byte):boolean;assembler;
asm
    mov dx,$3ce
    mov al,5
    out dx,al
    inc dx
    in al,dx
    and al,$F7
    out dx,al
    dec dx
    mov al,4
    out dx,al
    inc dx
    mov al,p
    out dx,al

    mov ax,$A000
    mov es,ax

    mov ax,l
    mov cx,80
    mul cx
    mov bx,ax
    xor al,al
    mov cx,20
@@bcle:
    or al,es:[bx]
    inc bx
    dec cx
    jnz @@bcle
    or al,al
    jz @@fin
    mov al,$ff
@@fin:
end;

function testcolone(c:integer;p:byte):boolean;assembler;
asm
    mov dx,$3ce
    mov al,5
    out dx,al
    inc dx
    in al,dx
    and al,$F7
    out dx,al
    dec dx
    mov al,4
    out dx,al
    inc dx
    mov al,p
    out dx,al

    mov ax,$A000
    mov es,ax

    mov bx,c
    xor al,al
    mov cx,120
@@bcle:
    or al,es:[bx]
    add bx,80
    dec cx
    jnz @@bcle
    or al,al
    jz @@fin
    mov al,$ff
@@fin:
end;


var
  pal:t_pal_16;
  fp:file of t_pal_16;
  fi:file;
  fo:text;

  m:t_m;
  col:array[0..79] of boolean;

  ok,c_ok:boolean;

  i,j,g:byte;

  x,y,x1,x2,y1,y2,c1,c2:integer;

  k:char;

  n:string;

begin
  n:=dirchoix('*.scr');

  init640_480;

  setpalcol(0,63);
  setpalcol(15,0);

  assign(fi,n);
  reset(fi,1);
  for i:=0 to 3 do begin
    asm
      mov dx,3C4h
      mov ax,102h
      mov cl,i
      shl ah,cl
      out dx,ax
    end;

    blockread(fi,ptr($A000,0)^,80*480);

  end;
  asm
    mov dx,3C4h
    mov ax,0f02h
    out dx,ax
  end;
  close(fi);

  x1:=-1;
  repeat
    inc(x1);
  until testcolone(x1,3) or (x1=20);
  x2:=20;
  repeat
    dec(x2);
  until testcolone(x2,3) or (x2=0);

  y1:=-1;
  repeat
    inc(y1);
  until testligne(y1,3) or (y1=120);

  y2:=120;
  repeat
    dec(y2);
  until testligne(y2,3) or (y2=0);

  setpix(x1*8,y1+120,2);
  setpix(x2*8,y2+120,9);

  asm
    mov dx,$3ce
    mov al,5
    out dx,al
    inc dx
    in al,dx
    and al,$F4
    out dx,al

    dec dx
    mov al,4
    out dx,al
    inc dx
    mov al,3
    out dx,al

    dec dx
    mov al,3
    out dx,al
    inc dx
    mov al,0
    out dx,al

    mov dx,$3c4
    mov al,2
    out dx,al
    inc dx
    mov al,15
    out dx,al


    mov ax,$A000
    mov es,ax

    xor si,si
    mov di,20

    mov dx,120
@@yb:
    mov cx,20
@@xb:
    mov al,es:[si]
    mov es:[di],al
    inc si
    inc di
    dec cx
    jne @@xb
    add si,60
    add di,60
    dec dx
    jne @@yb

    mov dx,$3c4
    mov al,2
    out dx,al
    inc dx
    mov al,2
    out dx,al

  end;

  fillchar(m,sizeof(m),0);

  for x:=0 to 79 do begin
    c_ok:=true;
    for y:=0 to 59 do begin
      ok:=false;
      g:=getpix(x*2,y*2);
      if g=0 then ok:=false
      else begin
        if g=1 then ok:=true;
        g:=getpix(x*2+1,y*2);
        if g=0 then ok:=false
        else begin
          if g=1 then ok:=true;
          g:=getpix(x*2,y*2+1);
          if g=0 then ok:=false
          else begin
            if g=1 then ok:=true;
            g:=getpix(x*2+1,y*2+1);
            if g=0 then ok:=false
            else begin
              if g=1 then ok:=true;
            end;
          end;
        end;
      end;
      c_ok:=c_ok and ok;
      if ok then begin
        setpix(x*2+160,y*2,2);
        setpix(x*2+160,y*2+1,2);
        setpix(x*2+161,y*2,2);
        setpix(x*2+161,y*2+1,2);
      end else m[x,y shr 3]:=m[x,y shr 3] or (1 shl (y and 7));
    end;
    col[x]:=c_ok;
  end;

  asm
    mov dx,$3c4
    mov al,2
    out dx,al
    inc dx
    mov al,15
    out dx,al
  end;

  c1:=-1;
  repeat
    inc(c1);
    setpix(c1*2+160,122,3);
  until not col[c1] or (c1=79);

  c2:=80;
  repeat
    dec(c2);
    setpix(c2*2+160,122,3);
  until not col[c2] or (c2=0);

  repeat
    setpix(320,240,i);
    i:=(i+1) and 15;
    vbl;
  until keypressed;

  k:=readkey;

  assign(fo,'mkweapon.inc');
  rewrite(fo);
  writeln(fo,';'+n);
  writeln(fo,'m_');
  writeln(fo,'	dc.b ',c1,',',c2-c1+1);
  for x:=c1 to c2 do 
    writeln(fo,'	dc.b ',m[x,0],',',m[x,1],',',m[x,2],',',m[x,3],',',
      m[x,4],',',m[x,5],',',m[x,6],',',m[x,7]);
  writeln(fo,'s_');
  writeln(fo,'	dc.w ',x1+10+y1*30);
  writeln(fo,'	dc.b ',x2-x1+1,',',y2-y1+1);
  for y:=y1 to y2 do
   for x:=x1 to x2 do begin
    asm
      mov dx,$3ce
      mov al,5
      out dx,al
      inc dx
      in al,dx
      and al,$F4
      out dx,al

      dec dx
      mov al,4
      out dx,al
      inc dx
      mov al,3
      out dx,al

      dec dx
      mov al,3
      out dx,al
      inc dx
      mov al,0
      out dx,al

      mov dx,$3c4
      mov al,2
      out dx,al
      inc dx
      mov al,15
      out dx,al


      mov ax,$A000
      mov es,ax

      mov ax,y
      mov dx,80
      mul dx
      mov bx,x
      add bx,ax

      mov al,es:[bx]
      mov g,al

    end;
    if x=x1 then begin
      writeln(fo);
      write(fo,'	dc.b ',g)
    end else write(fo,',',g)
  end;

  close(fo);

  fingfx;
end.