; World in 3D -- a ray caster engine for Ti-92
; Copyright (C) 1998-1999 Silicone <Julien.Viard@enst.fr>
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


;        title    World in 3d for Ti-92 V0.33Beta by Silicone

;   definition
	include	"tios.h"
	include	"flib.h"
;	include	"hexlib.h"
	xdef	_main
	xdef	_comment

;   liens    
        xdef    act_scr
        xdef    scr_offset
        xdef    k_opendoor
        xdef    k_fire

;*****************************************************
;       CODE
;*****************************************************
_main:
	jsr	flib::clr_scr

        move.w  #0,-(sp)  ; small font
        jsr     tios::FontSetSys
        add.l   #2,sp

        move.w #4,-(sp) ;print
        pea     bartext(PC)
        move.w #123,-(sp)
        move.w #0,-(sp)
        jsr tios::DrawStrXY
        lea 10(sp),sp

        move.w #2,act_scrp
        clr.w vbl_phase

	move.l	#$F08,-(sp)
	jsr	tios::HeapAlloc
	add.l	#4,sp
	move.w	d0,plane_handle
        bne     scr_handle_ok

        move.w #4,-(sp) ;print
        pea errortext(PC)
        move.w #0,-(sp)
        move.w #0,-(sp)
        jsr tios::DrawStrXY
        lea 10(sp),sp

        jsr flib::idle_loop
        rts

scr_handle_ok:

        move.w  #2,-(sp)  ; big font
        jsr     tios::FontSetSys
        add.l   #2,sp

        move.w 	#4,-(sp) ;print
        pea     titletext(PC)
        move.w 	#0,-(sp)
        move.w 	#0,-(sp)
        jsr 	tios::DrawStrXY
        lea 	10(sp),sp

        move.w  #1,-(sp)  ; normal font
        jsr     tios::FontSetSys
        add.l   #2,sp

        move.w 	#4,-(sp) ;print
        pea     titletext2(PC)
        move.w 	#2,-(sp)
        move.w 	#46,-(sp)
        jsr 	tios::DrawStrXY
        lea 	10(sp),sp


	move.w	plane_handle,d0
	tios::DEREF	d0,a6
	move.l	a6,d0

	add.l	#7,d0
	asr.l	#3,d0
	move.w	d0,scr_table+0

	asl.l	#3,d0
	move.l	d0,scr_offset


        move.l d0,a0

        move.l	#LCD_MEM,d0
        move.l  d0,a1
	move.l	d0,scr_offset+4
	lsr.l	#3,d0
	move.w	d0,scr_table+2

	move.w	#$F00/4-1,d0
_vid_clr1:
	move.l	(a1)+,(a0)+
	dbf.w	d0,_vid_clr1


	move.w	#$0700,d0
	trap	#1
	move.l	$64,old_int_1
	move.l	$68,old_int_2
	bclr.b	#2,$600001
	move.l	#int_1,$64
	move.l	#int_2,$68
	bset.b	#2,$600001
	trap	#1


        jsr init_invetory
main_loop:
        move.w act_scrp,d0
	lea	scr_table,a0
	move.w	0(a0,d0.w),($600010)
	eor.w	#2,d0
	move.w	d0,act_scrp

        add d0,d0
	lea	scr_offset,a0
	move.l	0(a0,d0.w),act_scr

        jsr effacement
        jsr affichage

;        move.l pos_x,d0  ; nbre
;        move.l #2,d1      ; ligne
;        move.l #1,d2      ; col
;        move.l #3,d4      ; nbdigit
;        jsr hexlib::put_hex

;        move.l pos_y,d0  ; nbre
;        move.l #3,d1      ; ligne
;        move.l #1,d2      ; col
;        move.l #3,d4      ; nbdigit
;        jsr hexlib::put_hex

;        move.w pos_a,d0  ; nbre
;        move.l #4,d1      ; ligne
;        move.l #1,d2      ; col
;        move.l #3,d4      ; nbdigit
;        jsr hexlib::put_hex

test_key:

        move.w  #$3bf,($600018) ; l6
        move.b #$FF,d2
        nop
        nop
        nop
        move.b  ($60001B),d0
        move.w  #$37f,($600018) ; l7 preparation

test_P:
	btst	#7,d0
        beq pause_mode


testenter2:
	btst	#6,d0
        seq k_opendoor

testf1:
	btst	#4,d0
	bne testf1_f
        move.b  #$FD,d2
testf1_f:

        move.b  ($60001B),d0
        move.w  #$3fe,($600018) ; l0 preparation

testf4:
	btst	#4,d0
	bne testf4_f
        and.b  #$FE,d2
testf4_f:

testapps:
	btst	#6,d0
	bne testapps_f
        move.b  #1,k_opendoor
testapps_f:


;        move.w  #$3fe,($600018) ; l0
;        nop
;        nop
;        nop
;        nop
        move.b  ($60001B),d3
        and.b d2,d3          ;"auto set" other key


;        move.w d3,d0  ; nbre
;        move.l #14,d1      ; ligne
;        move.l #0,d2      ; col
;        move.l #7,d4      ; nbdigit
;        jsr hexlib::put_bin

	btst	#2,d3    ; shift to quit
	beq	exit

test_arrow:
        cmp     #$FF,d3
	beq	testkeyend

testleft:
	btst	#4,d3
	bne	testleft_f
        sub.w #8,pos_a
        and.w #$1ff,pos_a
testleft_f:

testright:
	btst	#6,d3
	bne	testright_f
        add.w #8,pos_a
        and.w #$1ff,pos_a
testright_f:

        move.w pos_a,d6
        jsr calcsin  ; d1 = sin;  d0 = cos ; *128

        asr.b #2,d1  ; /4 =>pas 32
        asr.b #2,d0  ; /4 =>pas 32
        ext.w d1
        ext.l d1
        ext.w d0
        ext.l d0

        move.l pos_x,d4
        move.l pos_y,d5

testdown:
	btst	#7,d3
	bne	testdown_f
        sub.l     d0,d4
        sub.l     d1,d5
testdown_f:


testup:
	btst	#5,d3
	bne	testup_f
        add.l     d0,d4
        add.l     d1,d5
testup_f:


test2nd:
	btst	#0,d3
	bne test2nd_f
        sub.l     d1,d4
        add.l     d0,d5
test2nd_f:


testdiam:
	btst	#1,d3
	bne testdiam_f
        add.l     d1,d4
        sub.l     d0,d5
testdiam_f:


testhand:
	btst	#3,d3
        seq k_fire


        jsr testwall

        tst.b cameraon
        bne pause_mode

testkeyend:

        jsr test_obj_porte
        jsr test_fire

        jsr playstrm

wait_vbl:
	tst.w	vbl_phase
	bne	wait_vbl
	add.w	#5,vbl_phase   ; test #4 and #5 (cf sp test)

	bra	main_loop

exit:

	move.w	#$0700,d0
	trap	#1
	bclr.b	#2,$600001
	move.l	old_int_1,$64
	move.l	old_int_2,$68
	bset.b	#2,$600001
	trap	#1


	move.w	scr_table+2,($600010)


	move.w	plane_handle,-(sp)
	jsr	tios::HeapFree
	add.l	#2,sp


	rts
;*****************************************************
pause_mode:
	move.w	#$0700,d0
	trap	#1
	bclr.b	#2,$600001
	move.l	old_int_1,$64
	move.l	old_int_2,$68
	bset.b	#2,$600001
	trap	#1

        tst.b cameraon
        bne capt

        jsr flib::idle_loop

        move.w  #0,-(sp)  ; small font
        jsr     tios::FontSetSys
        add.l   #2,sp

        move.w #4,-(sp) ;print
        pea     bartext(PC)
        move.w #123,-(sp)
        move.w #0,-(sp)
        jsr tios::DrawStrXY
        lea 10(sp),sp

capt:

; **** fcamera ***
        move.w act_scrp,d0
	eor.w	#2,d0
        add d0,d0
	lea	scr_offset,a0
	move.l	0(a0,d0.w),camerascreen


SendHeader:
 tst.w	 ($75B0)
 bne SkipSend
 jsr tios::tx_free
 cmp.w	 #8,d0
 bcs SendHeader
 move.w  #5,-(a7)
 pea	 header(PC)
 jsr tios::transmit
 lea	 6(a7),a7
 moveq	 #63,d5
; cmp.b	 #1,layers
; beq Send
; moveq	 #127,d5
Send:
; lea	 $300,a2
 move.l camerascreen,a2
SendDRow:
 tst.w	 ($75B0)
 bne SkipSend
 jsr tios::tx_free
 cmp.w	 #70,d0
 bcs SendDRow
 move.w  #60,-(a7)
 move.l  a2,-(a7)
 jsr tios::transmit
 lea	 6(a7),a7
 adda	 #60,a2
 dbra	 d5,SendDRow
WaitDone:
 tst.w	 ($75B0)
 bne SkipSend
 jsr tios::tx_free
 cmp.b	 #$80,d0
 bne WaitDone
SkipSend:

; **** fcamera ***

        move.b #1,cameraon

        jsr flib::idle_loop

        move.w  #0,-(sp)  ; small font
        jsr     tios::FontSetSys
        add.l   #2,sp

        move.w #4,-(sp) ;print
        pea     bartext(PC)
        move.w #123,-(sp)
        move.w #0,-(sp)
        jsr tios::DrawStrXY
        lea 10(sp),sp

	move.w	#$0700,d0
	trap	#1
;	move.l	$64,old_int_1
;	move.l	$68,old_int_2
	bclr.b	#2,$600001
	move.l	#int_1,$64
	move.l	#int_2,$68
	bset.b	#2,$600001
	trap	#1

        bra testkeyend

;*****************************************************
; fcamera datas !
header	 dc.b "FCam"
layers	 dc.b 1

camerascreen dc.l 0

cameraon dc.b 0,0

;*****************************************************

int_1:
	add.w	#1,vbl_phase
	and.w	#3,vbl_phase

        rte  ; !!!!!!  fast !!!!! ( no callback to system !!!!!!!!!! )

;	move.l	old_int_1,-(sp)
;	rts

int_2:
	rte ; ??

;*****************************************************
;       DATA
;*****************************************************


errortext
	dc.b	"Memory rror !! :(",0
titletext
	dc.b	"World   3D",0
titletext2
	dc.b	"in",0
bartext
        dc.b    "World in 3D v0.33 Code by S|con, Gfx by Edgard SQUARE.  ",$1b," to quit!",0

_comment        dc.b    "World in 3D v0.33 / S|con",0

;*****************************************************
	BSS
;*****************************************************

old_int_1	dc.l	0

old_int_2	dc.l	0

vbl_phase	dc.w	0


plane_handle dc.w 0

act_scr:
        dc.l    0
act_scrp:
        dc.w    2

scr_offset:
	dc.l	0
	dc.l	0

scr_table:
	dc.w	0
	dc.w	0

k_opendoor:
        dc.b    0
k_fire:
        dc.b    0

;*****************************************************

	end
